// AvionicsDoc.h : interface of the CAvionicsDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_AVIONICSDOC_H__5E2A792B_19E7_11D6_8EB9_00010235688C__INCLUDED_)
#define AFX_AVIONICSDOC_H__5E2A792B_19E7_11D6_8EB9_00010235688C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "MyTreeView.h"
#include "MyListView.h"
#include "UDMCORBA.h"

class CAvionicsDoc : public CDocument
{
protected: // create from serialization only
	CAvionicsDoc();
	DECLARE_DYNCREATE(CAvionicsDoc)

// Attributes
public:
    CMyTreeView * TreeView;
    CMyListView * ListView;

	CString m_pathName;
	void OpenAIFFile();
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAvionicsDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation

public:
	virtual ~CAvionicsDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

//protected:
	Udm::SmartDataNetwork *backend;
//	UdmCORBA::CORBADataNetwork backend;
//	
// Generated message map functions
protected:
	//{{AFX_MSG(CAvionicsDoc)
	afx_msg void OnFileSaveAs();
	afx_msg void OnActionsAssignRates();
	afx_msg void OnActionsAssignComponents();
	afx_msg void OnFileClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AVIONICSDOC_H__5E2A792B_19E7_11D6_8EB9_00010235688C__INCLUDED_)
