// cpp(meta datanetwork format) source file LampDiagram.cpp generated from diagram LampDiagram
// generated on Wed Nov 13 20:41:50 2002
#include "stdafx.h"
#include "LampDiagram.h"
#include "UmlExt.h"

#include "UdmStatic.h"

namespace LampDiagram {

	Uml::Diagram umldiagram;

	Uml::Class RootFolder::meta;
	Uml::Class Switch::meta;
	Uml::Class Lamp::meta;
	Uml::Class Bulb::meta;
	Uml::Class ElectricTerminal::meta;
	Uml::Class ElectricDevice::meta;
	Uml::Class HalogenBulb::meta;
	Uml::Class Plug::meta;
	Uml::Class Wire::meta;
	Uml::Class ControlLink::meta;
	Uml::Attribute Switch::meta_Safe;
	Uml::Attribute Switch::meta_Amps;
	Uml::Attribute Lamp::meta_ArrayStr;
	Uml::Attribute Lamp::meta_ModelName;
	Uml::Attribute Lamp::meta_ArrayInt;
	Uml::Attribute Lamp::meta_ArrayBool;
	Uml::Attribute Lamp::meta_ArrayReal;
	Uml::Attribute Lamp::meta_TempArrayStr;
	Uml::Attribute Lamp::meta_TempArrayInt;
	Uml::Attribute Lamp::meta_TempArrayReal;
	Uml::Attribute Lamp::meta_TempArrayBoolean;
	Uml::Attribute Bulb::meta_Wattage;
	Uml::Attribute Bulb::meta_Voltage;
	Uml::Attribute ElectricTerminal::meta_position;
	Uml::Attribute ElectricTerminal::meta_Type;
	Uml::Attribute ElectricDevice::meta_MaxTempRating;
	Uml::Attribute ElectricDevice::meta_MaxVoltageRating;
	Uml::Attribute ElectricDevice::meta_position;
	Uml::Attribute ElectricDevice::meta_name;
	Uml::Attribute Plug::meta_Format;
	Uml::Attribute Wire::meta_Amps;
	Uml::Attribute ControlLink::meta_name;
	Uml::AssociationRole Switch::meta_src, Switch::meta_src_rev;
	Uml::AssociationRole Bulb::meta_dst, Bulb::meta_dst_rev;
	Uml::AssociationRole ElectricTerminal::meta_End1, ElectricTerminal::meta_End1_rev;
	Uml::AssociationRole ElectricTerminal::meta_End2, ElectricTerminal::meta_End2_rev;
	Uml::AssociationRole Wire::meta_End2_end_;
	Uml::AssociationRole Wire::meta_End1_end_;
	Uml::AssociationRole ControlLink::meta_dst_end_;
	Uml::AssociationRole ControlLink::meta_src_end_;
	Uml::CompositionParentRole Switch::meta_FunctionSwitch_Lamp_parent;
	Uml::CompositionParentRole Switch::meta_MainSwitch_Lamp_parent;
	Uml::CompositionParentRole Bulb::meta_Lamp_parent;
	Uml::CompositionParentRole ElectricTerminal::meta_ElectricDevice_parent;
	Uml::CompositionParentRole ElectricDevice::meta_RootFolder_parent;
	Uml::CompositionParentRole Plug::meta_Lamp_parent;
	Uml::CompositionParentRole Wire::meta_ElectricDevice_parent;
	Uml::CompositionParentRole ControlLink::meta_Lamp_parent;
	Uml::CompositionChildRole RootFolder::meta_ElectricDevice_children;
	Uml::CompositionChildRole Lamp::meta_MainSwitch;
	Uml::CompositionChildRole Lamp::meta_ControlLink_children;
	Uml::CompositionChildRole Lamp::meta_Bulb_children;
	Uml::CompositionChildRole Lamp::meta_FunctionSwitch;
	Uml::CompositionChildRole Lamp::meta_Plug_child;
	Uml::CompositionChildRole ElectricDevice::meta_ElectricTerminal_children;
	Uml::CompositionChildRole ElectricDevice::meta_Wire_children;
	void Initialize()
	{
		static bool first = true;
		if(!first) return;
		first = false;
		Uml::Initialize();

		ASSERT( umldiagram == Udm::null );
		UdmStatic::StaticDataNetwork * meta_dn = new UdmStatic::StaticDataNetwork(Uml::diagram);
		meta_dn->CreateNew("LampDiagram.mem", "", Uml::Diagram::meta, Udm::CHANGES_LOST_DEFAULT);
		umldiagram = Uml::Diagram::Cast(meta_dn->GetRootObject());
		umldiagram.name() ="LampDiagram";
		RootFolder::meta = Uml::Class::Create(umldiagram);
		Switch::meta = Uml::Class::Create(umldiagram);
		Lamp::meta = Uml::Class::Create(umldiagram);
		Bulb::meta = Uml::Class::Create(umldiagram);
		ElectricTerminal::meta = Uml::Class::Create(umldiagram);
		ElectricDevice::meta = Uml::Class::Create(umldiagram);
		HalogenBulb::meta = Uml::Class::Create(umldiagram);
		Plug::meta = Uml::Class::Create(umldiagram);
		Wire::meta = Uml::Class::Create(umldiagram);
		ControlLink::meta = Uml::Class::Create(umldiagram);
		Switch::meta_Safe = Uml::Attribute::Create(Switch::meta);
		Switch::meta_Amps = Uml::Attribute::Create(Switch::meta);
		Lamp::meta_ArrayStr = Uml::Attribute::Create(Lamp::meta);
		Lamp::meta_ModelName = Uml::Attribute::Create(Lamp::meta);
		Lamp::meta_ArrayInt = Uml::Attribute::Create(Lamp::meta);
		Lamp::meta_ArrayBool = Uml::Attribute::Create(Lamp::meta);
		Lamp::meta_ArrayReal = Uml::Attribute::Create(Lamp::meta);
		Lamp::meta_TempArrayStr = Uml::Attribute::Create(Lamp::meta);
		Lamp::meta_TempArrayInt = Uml::Attribute::Create(Lamp::meta);
		Lamp::meta_TempArrayReal = Uml::Attribute::Create(Lamp::meta);
		Lamp::meta_TempArrayBoolean = Uml::Attribute::Create(Lamp::meta);
		Bulb::meta_Wattage = Uml::Attribute::Create(Bulb::meta);
		Bulb::meta_Voltage = Uml::Attribute::Create(Bulb::meta);
		ElectricTerminal::meta_position = Uml::Attribute::Create(ElectricTerminal::meta);
		ElectricTerminal::meta_Type = Uml::Attribute::Create(ElectricTerminal::meta);
		ElectricDevice::meta_MaxTempRating = Uml::Attribute::Create(ElectricDevice::meta);
		ElectricDevice::meta_MaxVoltageRating = Uml::Attribute::Create(ElectricDevice::meta);
		ElectricDevice::meta_position = Uml::Attribute::Create(ElectricDevice::meta);
		ElectricDevice::meta_name = Uml::Attribute::Create(ElectricDevice::meta);
		Plug::meta_Format = Uml::Attribute::Create(Plug::meta);
		Wire::meta_Amps = Uml::Attribute::Create(Wire::meta);
		ControlLink::meta_name = Uml::Attribute::Create(ControlLink::meta);
		Uml::InitDiagram(umldiagram, "LampDiagram");

		RootFolder::meta.name() = "RootFolder";
		RootFolder::meta.isAbstract() = false;
		Switch::meta.name() = "Switch";
		Switch::meta.isAbstract() = false;
		Lamp::meta.name() = "Lamp";
		Lamp::meta.isAbstract() = false;
		Bulb::meta.name() = "Bulb";
		Bulb::meta.isAbstract() = false;
		ElectricTerminal::meta.name() = "ElectricTerminal";
		ElectricTerminal::meta.isAbstract() = false;
		ElectricDevice::meta.name() = "ElectricDevice";
		ElectricDevice::meta.isAbstract() = true;
		HalogenBulb::meta.name() = "HalogenBulb";
		HalogenBulb::meta.isAbstract() = false;
		Plug::meta.name() = "Plug";
		Plug::meta.isAbstract() = false;
		Wire::meta.name() = "Wire";
		Wire::meta.isAbstract() = false;
		ControlLink::meta.name() = "ControlLink";
		ControlLink::meta.isAbstract() = false;
		
		vector<string> Switch_Safe_dva;
		Switch::meta_Safe.name() = "Safe";
		Switch::meta_Safe.type() = "Boolean";
		Switch::meta_Safe.min() = 0;
		Switch::meta_Safe.max() = 1;
		Switch::meta_Safe.nonpersistent() = false;
		Switch::meta_Safe.ordered() = false;
		Switch::meta_Safe.visibility() = "public";
		Switch::meta_Safe.defvalue() = Switch_Safe_dva;
		vector<string> Switch_Amps_dva;
		Switch::meta_Amps.name() = "Amps";
		Switch::meta_Amps.type() = "Real";
		Switch::meta_Amps.min() = 0;
		Switch::meta_Amps.max() = 1;
		Switch::meta_Amps.nonpersistent() = false;
		Switch::meta_Amps.ordered() = false;
		Switch::meta_Amps.visibility() = "public";
		Switch::meta_Amps.defvalue() = Switch_Amps_dva;
		vector<string> Lamp_ArrayStr_dva;
		Lamp_ArrayStr_dva.push_back("second");
		Lamp_ArrayStr_dva.push_back("first");
		Lamp::meta_ArrayStr.name() = "ArrayStr";
		Lamp::meta_ArrayStr.type() = "String";
		Lamp::meta_ArrayStr.min() = 0;
		Lamp::meta_ArrayStr.max() = -1;
		Lamp::meta_ArrayStr.nonpersistent() = false;
		Lamp::meta_ArrayStr.ordered() = true;
		Lamp::meta_ArrayStr.visibility() = "public";
		Lamp::meta_ArrayStr.defvalue() = Lamp_ArrayStr_dva;
		vector<string> Lamp_ModelName_dva;
		Lamp_ModelName_dva.push_back("Default Lamp Name");
		Lamp::meta_ModelName.name() = "ModelName";
		Lamp::meta_ModelName.type() = "String";
		Lamp::meta_ModelName.min() = 1;
		Lamp::meta_ModelName.max() = 1;
		Lamp::meta_ModelName.nonpersistent() = false;
		Lamp::meta_ModelName.ordered() = false;
		Lamp::meta_ModelName.visibility() = "public";
		Lamp::meta_ModelName.defvalue() = Lamp_ModelName_dva;
		vector<string> Lamp_ArrayInt_dva;
		Lamp_ArrayInt_dva.push_back("5");
		Lamp_ArrayInt_dva.push_back("4");
		Lamp_ArrayInt_dva.push_back("3");
		Lamp_ArrayInt_dva.push_back("2");
		Lamp::meta_ArrayInt.name() = "ArrayInt";
		Lamp::meta_ArrayInt.type() = "Integer";
		Lamp::meta_ArrayInt.min() = 1;
		Lamp::meta_ArrayInt.max() = -1;
		Lamp::meta_ArrayInt.nonpersistent() = false;
		Lamp::meta_ArrayInt.ordered() = true;
		Lamp::meta_ArrayInt.visibility() = "public";
		Lamp::meta_ArrayInt.defvalue() = Lamp_ArrayInt_dva;
		vector<string> Lamp_ArrayBool_dva;
		Lamp_ArrayBool_dva.push_back("false");
		Lamp_ArrayBool_dva.push_back("true");
		Lamp_ArrayBool_dva.push_back("false");
		Lamp_ArrayBool_dva.push_back("true");
		Lamp::meta_ArrayBool.name() = "ArrayBool";
		Lamp::meta_ArrayBool.type() = "Boolean";
		Lamp::meta_ArrayBool.min() = 0;
		Lamp::meta_ArrayBool.max() = -1;
		Lamp::meta_ArrayBool.nonpersistent() = false;
		Lamp::meta_ArrayBool.ordered() = true;
		Lamp::meta_ArrayBool.visibility() = "public";
		Lamp::meta_ArrayBool.defvalue() = Lamp_ArrayBool_dva;
		vector<string> Lamp_ArrayReal_dva;
		Lamp_ArrayReal_dva.push_back("9");
		Lamp_ArrayReal_dva.push_back("8");
		Lamp_ArrayReal_dva.push_back("7");
		Lamp_ArrayReal_dva.push_back("6");
		Lamp::meta_ArrayReal.name() = "ArrayReal";
		Lamp::meta_ArrayReal.type() = "Real";
		Lamp::meta_ArrayReal.min() = 0;
		Lamp::meta_ArrayReal.max() = -1;
		Lamp::meta_ArrayReal.nonpersistent() = false;
		Lamp::meta_ArrayReal.ordered() = true;
		Lamp::meta_ArrayReal.visibility() = "public";
		Lamp::meta_ArrayReal.defvalue() = Lamp_ArrayReal_dva;
		vector<string> Lamp_TempArrayStr_dva;
		Lamp_TempArrayStr_dva.push_back("tempdef3");
		Lamp_TempArrayStr_dva.push_back("tempdef2");
		Lamp_TempArrayStr_dva.push_back("abcdef");
		Lamp::meta_TempArrayStr.name() = "TempArrayStr";
		Lamp::meta_TempArrayStr.type() = "String";
		Lamp::meta_TempArrayStr.min() = 0;
		Lamp::meta_TempArrayStr.max() = -1;
		Lamp::meta_TempArrayStr.nonpersistent() = true;
		Lamp::meta_TempArrayStr.ordered() = true;
		Lamp::meta_TempArrayStr.visibility() = "public";
		Lamp::meta_TempArrayStr.defvalue() = Lamp_TempArrayStr_dva;
		vector<string> Lamp_TempArrayInt_dva;
		Lamp_TempArrayInt_dva.push_back("9");
		Lamp_TempArrayInt_dva.push_back("8");
		Lamp_TempArrayInt_dva.push_back("5");
		Lamp_TempArrayInt_dva.push_back("6");
		Lamp::meta_TempArrayInt.name() = "TempArrayInt";
		Lamp::meta_TempArrayInt.type() = "Integer";
		Lamp::meta_TempArrayInt.min() = 0;
		Lamp::meta_TempArrayInt.max() = -1;
		Lamp::meta_TempArrayInt.nonpersistent() = true;
		Lamp::meta_TempArrayInt.ordered() = true;
		Lamp::meta_TempArrayInt.visibility() = "public";
		Lamp::meta_TempArrayInt.defvalue() = Lamp_TempArrayInt_dva;
		vector<string> Lamp_TempArrayReal_dva;
		Lamp_TempArrayReal_dva.push_back("40");
		Lamp_TempArrayReal_dva.push_back("35");
		Lamp_TempArrayReal_dva.push_back("26");
		Lamp_TempArrayReal_dva.push_back("17");
		Lamp::meta_TempArrayReal.name() = "TempArrayReal";
		Lamp::meta_TempArrayReal.type() = "Real";
		Lamp::meta_TempArrayReal.min() = 0;
		Lamp::meta_TempArrayReal.max() = -1;
		Lamp::meta_TempArrayReal.nonpersistent() = true;
		Lamp::meta_TempArrayReal.ordered() = true;
		Lamp::meta_TempArrayReal.visibility() = "public";
		Lamp::meta_TempArrayReal.defvalue() = Lamp_TempArrayReal_dva;
		vector<string> Lamp_TempArrayBoolean_dva;
		Lamp_TempArrayBoolean_dva.push_back("true");
		Lamp_TempArrayBoolean_dva.push_back("false");
		Lamp_TempArrayBoolean_dva.push_back("true");
		Lamp_TempArrayBoolean_dva.push_back("false");
		Lamp::meta_TempArrayBoolean.name() = "TempArrayBoolean";
		Lamp::meta_TempArrayBoolean.type() = "Boolean";
		Lamp::meta_TempArrayBoolean.min() = 0;
		Lamp::meta_TempArrayBoolean.max() = -1;
		Lamp::meta_TempArrayBoolean.nonpersistent() = true;
		Lamp::meta_TempArrayBoolean.ordered() = true;
		Lamp::meta_TempArrayBoolean.visibility() = "public";
		Lamp::meta_TempArrayBoolean.defvalue() = Lamp_TempArrayBoolean_dva;
		vector<string> Bulb_Wattage_dva;
		Bulb::meta_Wattage.name() = "Wattage";
		Bulb::meta_Wattage.type() = "Real";
		Bulb::meta_Wattage.min() = 1;
		Bulb::meta_Wattage.max() = 1;
		Bulb::meta_Wattage.nonpersistent() = false;
		Bulb::meta_Wattage.ordered() = false;
		Bulb::meta_Wattage.visibility() = "public";
		Bulb::meta_Wattage.defvalue() = Bulb_Wattage_dva;
		vector<string> Bulb_Voltage_dva;
		Bulb::meta_Voltage.name() = "Voltage";
		Bulb::meta_Voltage.type() = "Real";
		Bulb::meta_Voltage.min() = 0;
		Bulb::meta_Voltage.max() = 1;
		Bulb::meta_Voltage.nonpersistent() = false;
		Bulb::meta_Voltage.ordered() = false;
		Bulb::meta_Voltage.visibility() = "public";
		Bulb::meta_Voltage.defvalue() = Bulb_Voltage_dva;
		vector<string> ElectricTerminal_position_dva;
		ElectricTerminal::meta_position.name() = "position";
		ElectricTerminal::meta_position.type() = "String";
		ElectricTerminal::meta_position.min() = 0;
		ElectricTerminal::meta_position.max() = 1;
		ElectricTerminal::meta_position.nonpersistent() = false;
		ElectricTerminal::meta_position.ordered() = false;
		ElectricTerminal::meta_position.visibility() = "public";
		ElectricTerminal::meta_position.defvalue() = ElectricTerminal_position_dva;
		vector<string> ElectricTerminal_Type_dva;
		ElectricTerminal::meta_Type.name() = "Type";
		ElectricTerminal::meta_Type.type() = "String";
		ElectricTerminal::meta_Type.min() = 0;
		ElectricTerminal::meta_Type.max() = 1;
		ElectricTerminal::meta_Type.nonpersistent() = false;
		ElectricTerminal::meta_Type.ordered() = false;
		ElectricTerminal::meta_Type.visibility() = "public";
		ElectricTerminal::meta_Type.defvalue() = ElectricTerminal_Type_dva;
		vector<string> ElectricDevice_MaxTempRating_dva;
		ElectricDevice::meta_MaxTempRating.name() = "MaxTempRating";
		ElectricDevice::meta_MaxTempRating.type() = "Integer";
		ElectricDevice::meta_MaxTempRating.min() = 0;
		ElectricDevice::meta_MaxTempRating.max() = 1;
		ElectricDevice::meta_MaxTempRating.nonpersistent() = false;
		ElectricDevice::meta_MaxTempRating.ordered() = false;
		ElectricDevice::meta_MaxTempRating.visibility() = "public";
		ElectricDevice::meta_MaxTempRating.defvalue() = ElectricDevice_MaxTempRating_dva;
		vector<string> ElectricDevice_MaxVoltageRating_dva;
		ElectricDevice::meta_MaxVoltageRating.name() = "MaxVoltageRating";
		ElectricDevice::meta_MaxVoltageRating.type() = "Real";
		ElectricDevice::meta_MaxVoltageRating.min() = 0;
		ElectricDevice::meta_MaxVoltageRating.max() = 1;
		ElectricDevice::meta_MaxVoltageRating.nonpersistent() = false;
		ElectricDevice::meta_MaxVoltageRating.ordered() = false;
		ElectricDevice::meta_MaxVoltageRating.visibility() = "public";
		ElectricDevice::meta_MaxVoltageRating.defvalue() = ElectricDevice_MaxVoltageRating_dva;
		vector<string> ElectricDevice_position_dva;
		ElectricDevice::meta_position.name() = "position";
		ElectricDevice::meta_position.type() = "String";
		ElectricDevice::meta_position.min() = 0;
		ElectricDevice::meta_position.max() = 1;
		ElectricDevice::meta_position.nonpersistent() = false;
		ElectricDevice::meta_position.ordered() = false;
		ElectricDevice::meta_position.visibility() = "public";
		ElectricDevice::meta_position.defvalue() = ElectricDevice_position_dva;
		vector<string> ElectricDevice_name_dva;
		ElectricDevice::meta_name.name() = "name";
		ElectricDevice::meta_name.type() = "String";
		ElectricDevice::meta_name.min() = 0;
		ElectricDevice::meta_name.max() = 1;
		ElectricDevice::meta_name.nonpersistent() = false;
		ElectricDevice::meta_name.ordered() = false;
		ElectricDevice::meta_name.visibility() = "public";
		ElectricDevice::meta_name.defvalue() = ElectricDevice_name_dva;
		vector<string> Plug_Format_dva;
		Plug::meta_Format.name() = "Format";
		Plug::meta_Format.type() = "String";
		Plug::meta_Format.min() = 0;
		Plug::meta_Format.max() = 1;
		Plug::meta_Format.nonpersistent() = false;
		Plug::meta_Format.ordered() = false;
		Plug::meta_Format.visibility() = "public";
		Plug::meta_Format.defvalue() = Plug_Format_dva;
		vector<string> Wire_Amps_dva;
		Wire::meta_Amps.name() = "Amps";
		Wire::meta_Amps.type() = "Real";
		Wire::meta_Amps.min() = 0;
		Wire::meta_Amps.max() = 1;
		Wire::meta_Amps.nonpersistent() = false;
		Wire::meta_Amps.ordered() = false;
		Wire::meta_Amps.visibility() = "public";
		Wire::meta_Amps.defvalue() = Wire_Amps_dva;
		vector<string> ControlLink_name_dva;
		ControlLink::meta_name.name() = "name";
		ControlLink::meta_name.type() = "String";
		ControlLink::meta_name.min() = 0;
		ControlLink::meta_name.max() = 1;
		ControlLink::meta_name.nonpersistent() = false;
		ControlLink::meta_name.ordered() = false;
		ControlLink::meta_name.visibility() = "public";
		ControlLink::meta_name.defvalue() = ControlLink_name_dva;
		
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			ass.name() = "ControlLink";
			ass.assocClass() = ControlLink::meta;
			Switch::meta_src = Uml::AssociationRole::Create(ass);
			Switch::meta_src.name() = "src";
			Switch::meta_src.min() = 0;
			Switch::meta_src.max() = -1;
			Switch::meta_src.isNavigable() = true;
			Switch::meta_src.isPrimary() = false;
			Switch::meta_src.target() = Bulb::meta;
			ControlLink::meta_src_end_ = Bulb::meta_dst_rev = Switch::meta_src;
			Bulb::meta_dst = Uml::AssociationRole::Create(ass);
			Bulb::meta_dst.name() = "dst";
			Bulb::meta_dst.min() = 0;
			Bulb::meta_dst.max() = -1;
			Bulb::meta_dst.isNavigable() = true;
			Bulb::meta_dst.isPrimary() = false;
			Bulb::meta_dst.target() = Switch::meta;
			ControlLink::meta_dst_end_ = Switch::meta_src_rev = Bulb::meta_dst;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			ass.name() = "Wire";
			ass.assocClass() = Wire::meta;
			ElectricTerminal::meta_End1 = Uml::AssociationRole::Create(ass);
			ElectricTerminal::meta_End1.name() = "End1";
			ElectricTerminal::meta_End1.min() = 0;
			ElectricTerminal::meta_End1.max() = -1;
			ElectricTerminal::meta_End1.isNavigable() = true;
			ElectricTerminal::meta_End1.isPrimary() = false;
			ElectricTerminal::meta_End1.target() = ElectricTerminal::meta;
			Wire::meta_End1_end_ = ElectricTerminal::meta_End2_rev = ElectricTerminal::meta_End1;
			ElectricTerminal::meta_End2 = Uml::AssociationRole::Create(ass);
			ElectricTerminal::meta_End2.name() = "End2";
			ElectricTerminal::meta_End2.min() = 0;
			ElectricTerminal::meta_End2.max() = -1;
			ElectricTerminal::meta_End2.isNavigable() = true;
			ElectricTerminal::meta_End2.isPrimary() = false;
			ElectricTerminal::meta_End2.target() = ElectricTerminal::meta;
			Wire::meta_End2_end_ = ElectricTerminal::meta_End1_rev = ElectricTerminal::meta_End2;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			ElectricDevice::meta_RootFolder_parent = Uml::CompositionParentRole::Create(comp);
			ElectricDevice::meta_RootFolder_parent.name() = "RootFolder_parent";
			ElectricDevice::meta_RootFolder_parent.isNavigable() = true;
			ElectricDevice::meta_RootFolder_parent.target() = RootFolder::meta;
			RootFolder::meta_ElectricDevice_children = Uml::CompositionChildRole::Create(comp);
			RootFolder::meta_ElectricDevice_children.name() = "ElectricDevice";
			RootFolder::meta_ElectricDevice_children.min() = 0;
			RootFolder::meta_ElectricDevice_children.max() = -1;
			RootFolder::meta_ElectricDevice_children.isNavigable() = true;
			RootFolder::meta_ElectricDevice_children.target() = ElectricDevice::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			ElectricTerminal::meta_ElectricDevice_parent = Uml::CompositionParentRole::Create(comp);
			ElectricTerminal::meta_ElectricDevice_parent.name() = "ElectricDevice_parent";
			ElectricTerminal::meta_ElectricDevice_parent.isNavigable() = true;
			ElectricTerminal::meta_ElectricDevice_parent.target() = ElectricDevice::meta;
			ElectricDevice::meta_ElectricTerminal_children = Uml::CompositionChildRole::Create(comp);
			ElectricDevice::meta_ElectricTerminal_children.name() = "ElectricTerminal";
			ElectricDevice::meta_ElectricTerminal_children.min() = 0;
			ElectricDevice::meta_ElectricTerminal_children.max() = -1;
			ElectricDevice::meta_ElectricTerminal_children.isNavigable() = true;
			ElectricDevice::meta_ElectricTerminal_children.target() = ElectricTerminal::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Wire::meta_ElectricDevice_parent = Uml::CompositionParentRole::Create(comp);
			Wire::meta_ElectricDevice_parent.name() = "ElectricDevice_parent";
			Wire::meta_ElectricDevice_parent.isNavigable() = true;
			Wire::meta_ElectricDevice_parent.target() = ElectricDevice::meta;
			ElectricDevice::meta_Wire_children = Uml::CompositionChildRole::Create(comp);
			ElectricDevice::meta_Wire_children.name() = "Wire";
			ElectricDevice::meta_Wire_children.min() = 0;
			ElectricDevice::meta_Wire_children.max() = -1;
			ElectricDevice::meta_Wire_children.isNavigable() = true;
			ElectricDevice::meta_Wire_children.target() = Wire::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Switch::meta_FunctionSwitch_Lamp_parent = Uml::CompositionParentRole::Create(comp);
			Switch::meta_FunctionSwitch_Lamp_parent.name() = "FunctionSwitch_Lamp_parent";
			Switch::meta_FunctionSwitch_Lamp_parent.isNavigable() = true;
			Switch::meta_FunctionSwitch_Lamp_parent.target() = Lamp::meta;
			Lamp::meta_FunctionSwitch = Uml::CompositionChildRole::Create(comp);
			Lamp::meta_FunctionSwitch.name() = "FunctionSwitch";
			Lamp::meta_FunctionSwitch.min() = 0;
			Lamp::meta_FunctionSwitch.max() = -1;
			Lamp::meta_FunctionSwitch.isNavigable() = true;
			Lamp::meta_FunctionSwitch.target() = Switch::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Switch::meta_MainSwitch_Lamp_parent = Uml::CompositionParentRole::Create(comp);
			Switch::meta_MainSwitch_Lamp_parent.name() = "MainSwitch_Lamp_parent";
			Switch::meta_MainSwitch_Lamp_parent.isNavigable() = true;
			Switch::meta_MainSwitch_Lamp_parent.target() = Lamp::meta;
			Lamp::meta_MainSwitch = Uml::CompositionChildRole::Create(comp);
			Lamp::meta_MainSwitch.name() = "MainSwitch";
			Lamp::meta_MainSwitch.min() = 1;
			Lamp::meta_MainSwitch.max() = 1;
			Lamp::meta_MainSwitch.isNavigable() = true;
			Lamp::meta_MainSwitch.target() = Switch::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			ControlLink::meta_Lamp_parent = Uml::CompositionParentRole::Create(comp);
			ControlLink::meta_Lamp_parent.name() = "Lamp_parent";
			ControlLink::meta_Lamp_parent.isNavigable() = true;
			ControlLink::meta_Lamp_parent.target() = Lamp::meta;
			Lamp::meta_ControlLink_children = Uml::CompositionChildRole::Create(comp);
			Lamp::meta_ControlLink_children.name() = "ControlLink";
			Lamp::meta_ControlLink_children.min() = 0;
			Lamp::meta_ControlLink_children.max() = -1;
			Lamp::meta_ControlLink_children.isNavigable() = true;
			Lamp::meta_ControlLink_children.target() = ControlLink::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Bulb::meta_Lamp_parent = Uml::CompositionParentRole::Create(comp);
			Bulb::meta_Lamp_parent.name() = "Lamp_parent";
			Bulb::meta_Lamp_parent.isNavigable() = true;
			Bulb::meta_Lamp_parent.target() = Lamp::meta;
			Lamp::meta_Bulb_children = Uml::CompositionChildRole::Create(comp);
			Lamp::meta_Bulb_children.name() = "Bulb";
			Lamp::meta_Bulb_children.min() = 1;
			Lamp::meta_Bulb_children.max() = -1;
			Lamp::meta_Bulb_children.isNavigable() = true;
			Lamp::meta_Bulb_children.target() = Bulb::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Plug::meta_Lamp_parent = Uml::CompositionParentRole::Create(comp);
			Plug::meta_Lamp_parent.name() = "Lamp_parent";
			Plug::meta_Lamp_parent.isNavigable() = true;
			Plug::meta_Lamp_parent.target() = Lamp::meta;
			Lamp::meta_Plug_child = Uml::CompositionChildRole::Create(comp);
			Lamp::meta_Plug_child.name() = "Plug";
			Lamp::meta_Plug_child.min() = 1;
			Lamp::meta_Plug_child.max() = 1;
			Lamp::meta_Plug_child.isNavigable() = true;
			Lamp::meta_Plug_child.target() = Plug::meta;
		}
		Bulb::meta.subTypes() +=  HalogenBulb::meta;
		ElectricDevice::meta.subTypes() +=  Switch::meta;
		ElectricDevice::meta.subTypes() +=  Lamp::meta;
		ElectricDevice::meta.subTypes() +=  Bulb::meta;
		ElectricDevice::meta.subTypes() +=  Plug::meta;
		
	}
	Udm::UdmDiagram diagram = { &umldiagram, Initialize };
}
// END LampDiagram.cpp
