// cpp(meta datanetwork format) source file IIF.cpp generated from diagram IIF
// generated on Wed Nov 13 21:01:06 2002
#include "stdafx.h"
#include "IIF.h"
#include "UmlExt.h"

#include "UdmStatic.h"

namespace IIF {

	Uml::Diagram umldiagram;

	Uml::Class System::meta;
	Uml::Class PreemptionTimeStamp::meta;
	Uml::Class Process::meta;
	Uml::Class Processor::meta;
	Uml::Class Network::meta;
	Uml::Class OperatingSystem::meta;
	Uml::Class Thread::meta;
	Uml::Class FrameController::meta;
	Uml::Class TimeService::meta;
	Uml::Class PersistenceService::meta;
	Uml::Class IIFObject::meta;
	Uml::Class Schedule::meta;
	Uml::Class Component::meta;
	Uml::Class EventPort::meta;
	Uml::Class EventChannel::meta;
	Uml::Class Scheduler::meta;
	Uml::Class Timer::meta;
	Uml::Class DispatchingQueue::meta;
	Uml::Class Rate::meta;
	Uml::Class PublishPort::meta;
	Uml::Class SubscribePort::meta;
	Uml::Class Event::meta;
	Uml::Class Action::meta;
	Uml::Class ComponentMode::meta;
	Uml::Class EventDependencyTimeStamp::meta;
	Uml::Class SuppliedEventTimeStamp::meta;
	Uml::Class QueueReorderingTimeStamp::meta;
	Uml::Class FrameTimeStamp::meta;
	Uml::Class ThreadedTimeStamp::meta;
	Uml::Class ModeTimeStamp::meta;
	Uml::Class ConsumedEventTimeStamp::meta;
	Uml::Class RemoteMethodTimeStamp::meta;
	Uml::Class Timestamp::meta;
	Uml::Attribute System::meta_globalClockSkew;
	Uml::Attribute PreemptionTimeStamp::meta_type;
	Uml::Attribute Process::meta_processNumber;
	Uml::Attribute Processor::meta_processorBusSpeed;
	Uml::Attribute Processor::meta_processorSpeed;
	Uml::Attribute Processor::meta_processorMemory;
	Uml::Attribute Processor::meta_clockRes;
	Uml::Attribute Network::meta_networkLatency;
	Uml::Attribute Network::meta_networkBandwidth;
	Uml::Attribute OperatingSystem::meta_schedulingPolicyId;
	Uml::Attribute OperatingSystem::meta_numThreadPriorities;
	Uml::Attribute Thread::meta_stackSize;
	Uml::Attribute Thread::meta_threadPriority;
	Uml::Attribute IIFObject::meta_name;
	Uml::Attribute Component::meta_GroupId;
	Uml::Attribute Component::meta_ItemId;
	Uml::Attribute Component::meta_componentSize;
	Uml::Attribute DispatchingQueue::meta_dispatchingQueueSize;
	Uml::Attribute DispatchingQueue::meta_dispatchingQueueId;
	Uml::Attribute SubscribePort::meta_isERM_Subscriber;
	Uml::Attribute SubscribePort::meta_eventsCorrelated;
	Uml::Attribute Event::meta_eventSourceTypeId;
	Uml::Attribute ComponentMode::meta_mode;
	Uml::Attribute SuppliedEventTimeStamp::meta_type;
	Uml::Attribute QueueReorderingTimeStamp::meta_type;
	Uml::Attribute FrameTimeStamp::meta_type;
	Uml::Attribute ConsumedEventTimeStamp::meta_type;
	Uml::Attribute RemoteMethodTimeStamp::meta_type;
	Uml::Attribute Timestamp::meta_timestamp;
	Uml::AssociationRole PreemptionTimeStamp::meta_Thread;
	Uml::AssociationRole Processor::meta_Network;
	Uml::AssociationRole Network::meta_Processor;
	Uml::AssociationRole Thread::meta_PreemptionTimeStamp;
	Uml::AssociationRole Thread::meta_ThreadedTimeStamp;
	Uml::AssociationRole Thread::meta_DispatchingQueue;
	Uml::AssociationRole Schedule::meta_Component;
	Uml::AssociationRole Schedule::meta_dispatchingQueue;
	Uml::AssociationRole Component::meta_Schedule;
	Uml::AssociationRole Component::meta_ComponentMode;
	Uml::AssociationRole EventChannel::meta_Scheduler;
	Uml::AssociationRole Scheduler::meta_EventChannel;
	Uml::AssociationRole Timer::meta_rate;
	Uml::AssociationRole DispatchingQueue::meta_servicedBy;
	Uml::AssociationRole DispatchingQueue::meta_Schedule;
	Uml::AssociationRole DispatchingQueue::meta_QueueReorderingTimeStamp;
	Uml::AssociationRole Rate::meta_Timer;
	Uml::AssociationRole Rate::meta_FrameTimeStamp;
	Uml::AssociationRole PublishPort::meta_ConsumedEventTimeStamp;
	Uml::AssociationRole PublishPort::meta_SuppliedEventTimeStamp;
	Uml::AssociationRole SubscribePort::meta_ConsumedEventTimeStamp;
	Uml::AssociationRole SubscribePort::meta_EventDependencyTimeStamp;
	Uml::AssociationRole Event::meta_eventtimestamp;
	Uml::AssociationRole Event::meta_eventtimestamps;
	Uml::AssociationRole Event::meta_SuppliedEventTimeStamp;
	Uml::AssociationRole Event::meta_ConsumedEventTimeStamp;
	Uml::AssociationRole Action::meta_RemoteMethodTimeStamp;
	Uml::AssociationRole ComponentMode::meta_Component;
	Uml::AssociationRole EventDependencyTimeStamp::meta_SubscribePort;
	Uml::AssociationRole EventDependencyTimeStamp::meta_incomingEvent;
	Uml::AssociationRole EventDependencyTimeStamp::meta_outgoingEvents;
	Uml::AssociationRole SuppliedEventTimeStamp::meta_PublishPort;
	Uml::AssociationRole SuppliedEventTimeStamp::meta_Event;
	Uml::AssociationRole QueueReorderingTimeStamp::meta_DispatchingQueue;
	Uml::AssociationRole FrameTimeStamp::meta_Rate;
	Uml::AssociationRole ThreadedTimeStamp::meta_thread;
	Uml::AssociationRole ConsumedEventTimeStamp::meta_PublishPort;
	Uml::AssociationRole ConsumedEventTimeStamp::meta_SubscribePort;
	Uml::AssociationRole ConsumedEventTimeStamp::meta_Event;
	Uml::AssociationRole RemoteMethodTimeStamp::meta_Action;
	Uml::CompositionParentRole Process::meta_Processor_parent;
	Uml::CompositionParentRole Processor::meta_System_parent;
	Uml::CompositionParentRole Network::meta_System_parent;
	Uml::CompositionParentRole OperatingSystem::meta_Processor_parent;
	Uml::CompositionParentRole Thread::meta_Process_parent;
	Uml::CompositionParentRole FrameController::meta_Process_parent;
	Uml::CompositionParentRole TimeService::meta_Process_parent;
	Uml::CompositionParentRole PersistenceService::meta_Process_parent;
	Uml::CompositionParentRole Schedule::meta_Scheduler_parent;
	Uml::CompositionParentRole Component::meta_owner;
	Uml::CompositionParentRole EventPort::meta_Component_parent;
	Uml::CompositionParentRole EventPort::meta_TimeService_parent;
	Uml::CompositionParentRole EventPort::meta_FrameController_parent;
	Uml::CompositionParentRole EventPort::meta_PersistenceService_parent;
	Uml::CompositionParentRole EventChannel::meta_Process_parent;
	Uml::CompositionParentRole Scheduler::meta_Process_parent;
	Uml::CompositionParentRole Timer::meta_EventChannel_parent;
	Uml::CompositionParentRole DispatchingQueue::meta_EventChannel_parent;
	Uml::CompositionParentRole Rate::meta_Thread_parent;
	Uml::CompositionParentRole PublishPort::meta_Timer_parent;
	Uml::CompositionParentRole Event::meta_PublishPort_parent;
	Uml::CompositionParentRole Action::meta_Component_parent;
	Uml::CompositionParentRole ComponentMode::meta_frameModes_ModeTimeStamp_parent;
	Uml::CompositionParentRole Timestamp::meta_System_parent;
	Uml::CompositionChildRole System::meta_Timestamp_children;
	Uml::CompositionChildRole System::meta_Network_children;
	Uml::CompositionChildRole System::meta_Processor_children;
	Uml::CompositionChildRole Process::meta_EventChannel_child;
	Uml::CompositionChildRole Process::meta_Thread_children;
	Uml::CompositionChildRole Process::meta_Scheduler_child;
	Uml::CompositionChildRole Process::meta_Component_children;
	Uml::CompositionChildRole Process::meta_FrameController_child;
	Uml::CompositionChildRole Process::meta_TimeService_child;
	Uml::CompositionChildRole Process::meta_PersistenceService_child;
	Uml::CompositionChildRole Processor::meta_OperatingSystem_child;
	Uml::CompositionChildRole Processor::meta_Process_children;
	Uml::CompositionChildRole Thread::meta_Rate_child;
	Uml::CompositionChildRole FrameController::meta_EventPort_children;
	Uml::CompositionChildRole TimeService::meta_EventPort_children;
	Uml::CompositionChildRole PersistenceService::meta_EventPort_children;
	Uml::CompositionChildRole Component::meta_Action_children;
	Uml::CompositionChildRole Component::meta_EventPort_children;
	Uml::CompositionChildRole EventChannel::meta_DispatchingQueue_children;
	Uml::CompositionChildRole EventChannel::meta_Timer_children;
	Uml::CompositionChildRole Scheduler::meta_Schedule_children;
	Uml::CompositionChildRole Timer::meta_PublishPort_children;
	Uml::CompositionChildRole PublishPort::meta_Event_children;
	Uml::CompositionChildRole ModeTimeStamp::meta_frameModes;
	void Initialize()
	{
		static bool first = true;
		if(!first) return;
		first = false;
		Uml::Initialize();

		ASSERT( umldiagram == Udm::null );
		UdmStatic::StaticDataNetwork * meta_dn = new UdmStatic::StaticDataNetwork(Uml::diagram);
		meta_dn->CreateNew("IIF.mem", "", Uml::Diagram::meta, Udm::CHANGES_LOST_DEFAULT);
		umldiagram = Uml::Diagram::Cast(meta_dn->GetRootObject());
		umldiagram.name() ="IIF";
		System::meta = Uml::Class::Create(umldiagram);
		PreemptionTimeStamp::meta = Uml::Class::Create(umldiagram);
		Process::meta = Uml::Class::Create(umldiagram);
		Processor::meta = Uml::Class::Create(umldiagram);
		Network::meta = Uml::Class::Create(umldiagram);
		OperatingSystem::meta = Uml::Class::Create(umldiagram);
		Thread::meta = Uml::Class::Create(umldiagram);
		FrameController::meta = Uml::Class::Create(umldiagram);
		TimeService::meta = Uml::Class::Create(umldiagram);
		PersistenceService::meta = Uml::Class::Create(umldiagram);
		IIFObject::meta = Uml::Class::Create(umldiagram);
		Schedule::meta = Uml::Class::Create(umldiagram);
		Component::meta = Uml::Class::Create(umldiagram);
		EventPort::meta = Uml::Class::Create(umldiagram);
		EventChannel::meta = Uml::Class::Create(umldiagram);
		Scheduler::meta = Uml::Class::Create(umldiagram);
		Timer::meta = Uml::Class::Create(umldiagram);
		DispatchingQueue::meta = Uml::Class::Create(umldiagram);
		Rate::meta = Uml::Class::Create(umldiagram);
		PublishPort::meta = Uml::Class::Create(umldiagram);
		SubscribePort::meta = Uml::Class::Create(umldiagram);
		Event::meta = Uml::Class::Create(umldiagram);
		Action::meta = Uml::Class::Create(umldiagram);
		ComponentMode::meta = Uml::Class::Create(umldiagram);
		EventDependencyTimeStamp::meta = Uml::Class::Create(umldiagram);
		SuppliedEventTimeStamp::meta = Uml::Class::Create(umldiagram);
		QueueReorderingTimeStamp::meta = Uml::Class::Create(umldiagram);
		FrameTimeStamp::meta = Uml::Class::Create(umldiagram);
		ThreadedTimeStamp::meta = Uml::Class::Create(umldiagram);
		ModeTimeStamp::meta = Uml::Class::Create(umldiagram);
		ConsumedEventTimeStamp::meta = Uml::Class::Create(umldiagram);
		RemoteMethodTimeStamp::meta = Uml::Class::Create(umldiagram);
		Timestamp::meta = Uml::Class::Create(umldiagram);
		System::meta_globalClockSkew = Uml::Attribute::Create(System::meta);
		PreemptionTimeStamp::meta_type = Uml::Attribute::Create(PreemptionTimeStamp::meta);
		Process::meta_processNumber = Uml::Attribute::Create(Process::meta);
		Processor::meta_processorBusSpeed = Uml::Attribute::Create(Processor::meta);
		Processor::meta_processorSpeed = Uml::Attribute::Create(Processor::meta);
		Processor::meta_processorMemory = Uml::Attribute::Create(Processor::meta);
		Processor::meta_clockRes = Uml::Attribute::Create(Processor::meta);
		Network::meta_networkLatency = Uml::Attribute::Create(Network::meta);
		Network::meta_networkBandwidth = Uml::Attribute::Create(Network::meta);
		OperatingSystem::meta_schedulingPolicyId = Uml::Attribute::Create(OperatingSystem::meta);
		OperatingSystem::meta_numThreadPriorities = Uml::Attribute::Create(OperatingSystem::meta);
		Thread::meta_stackSize = Uml::Attribute::Create(Thread::meta);
		Thread::meta_threadPriority = Uml::Attribute::Create(Thread::meta);
		IIFObject::meta_name = Uml::Attribute::Create(IIFObject::meta);
		Component::meta_GroupId = Uml::Attribute::Create(Component::meta);
		Component::meta_ItemId = Uml::Attribute::Create(Component::meta);
		Component::meta_componentSize = Uml::Attribute::Create(Component::meta);
		DispatchingQueue::meta_dispatchingQueueSize = Uml::Attribute::Create(DispatchingQueue::meta);
		DispatchingQueue::meta_dispatchingQueueId = Uml::Attribute::Create(DispatchingQueue::meta);
		SubscribePort::meta_isERM_Subscriber = Uml::Attribute::Create(SubscribePort::meta);
		SubscribePort::meta_eventsCorrelated = Uml::Attribute::Create(SubscribePort::meta);
		Event::meta_eventSourceTypeId = Uml::Attribute::Create(Event::meta);
		ComponentMode::meta_mode = Uml::Attribute::Create(ComponentMode::meta);
		SuppliedEventTimeStamp::meta_type = Uml::Attribute::Create(SuppliedEventTimeStamp::meta);
		QueueReorderingTimeStamp::meta_type = Uml::Attribute::Create(QueueReorderingTimeStamp::meta);
		FrameTimeStamp::meta_type = Uml::Attribute::Create(FrameTimeStamp::meta);
		ConsumedEventTimeStamp::meta_type = Uml::Attribute::Create(ConsumedEventTimeStamp::meta);
		RemoteMethodTimeStamp::meta_type = Uml::Attribute::Create(RemoteMethodTimeStamp::meta);
		Timestamp::meta_timestamp = Uml::Attribute::Create(Timestamp::meta);
		Uml::InitDiagram(umldiagram, "IIF");

		System::meta.name() = "System";
		System::meta.isAbstract() = false;
		PreemptionTimeStamp::meta.name() = "PreemptionTimeStamp";
		PreemptionTimeStamp::meta.isAbstract() = false;
		Process::meta.name() = "Process";
		Process::meta.isAbstract() = false;
		Processor::meta.name() = "Processor";
		Processor::meta.isAbstract() = false;
		Network::meta.name() = "Network";
		Network::meta.isAbstract() = false;
		OperatingSystem::meta.name() = "OperatingSystem";
		OperatingSystem::meta.isAbstract() = false;
		Thread::meta.name() = "Thread";
		Thread::meta.isAbstract() = false;
		FrameController::meta.name() = "FrameController";
		FrameController::meta.isAbstract() = false;
		TimeService::meta.name() = "TimeService";
		TimeService::meta.isAbstract() = false;
		PersistenceService::meta.name() = "PersistenceService";
		PersistenceService::meta.isAbstract() = false;
		IIFObject::meta.name() = "IIFObject";
		IIFObject::meta.isAbstract() = true;
		Schedule::meta.name() = "Schedule";
		Schedule::meta.isAbstract() = false;
		Component::meta.name() = "Component";
		Component::meta.isAbstract() = false;
		EventPort::meta.name() = "EventPort";
		EventPort::meta.isAbstract() = true;
		EventChannel::meta.name() = "EventChannel";
		EventChannel::meta.isAbstract() = false;
		Scheduler::meta.name() = "Scheduler";
		Scheduler::meta.isAbstract() = false;
		Timer::meta.name() = "Timer";
		Timer::meta.isAbstract() = false;
		DispatchingQueue::meta.name() = "DispatchingQueue";
		DispatchingQueue::meta.isAbstract() = false;
		Rate::meta.name() = "Rate";
		Rate::meta.isAbstract() = false;
		PublishPort::meta.name() = "PublishPort";
		PublishPort::meta.isAbstract() = false;
		SubscribePort::meta.name() = "SubscribePort";
		SubscribePort::meta.isAbstract() = false;
		Event::meta.name() = "Event";
		Event::meta.isAbstract() = false;
		Action::meta.name() = "Action";
		Action::meta.isAbstract() = false;
		ComponentMode::meta.name() = "ComponentMode";
		ComponentMode::meta.isAbstract() = false;
		EventDependencyTimeStamp::meta.name() = "EventDependencyTimeStamp";
		EventDependencyTimeStamp::meta.isAbstract() = false;
		SuppliedEventTimeStamp::meta.name() = "SuppliedEventTimeStamp";
		SuppliedEventTimeStamp::meta.isAbstract() = false;
		QueueReorderingTimeStamp::meta.name() = "QueueReorderingTimeStamp";
		QueueReorderingTimeStamp::meta.isAbstract() = false;
		FrameTimeStamp::meta.name() = "FrameTimeStamp";
		FrameTimeStamp::meta.isAbstract() = false;
		ThreadedTimeStamp::meta.name() = "ThreadedTimeStamp";
		ThreadedTimeStamp::meta.isAbstract() = false;
		ModeTimeStamp::meta.name() = "ModeTimeStamp";
		ModeTimeStamp::meta.isAbstract() = false;
		ConsumedEventTimeStamp::meta.name() = "ConsumedEventTimeStamp";
		ConsumedEventTimeStamp::meta.isAbstract() = false;
		RemoteMethodTimeStamp::meta.name() = "RemoteMethodTimeStamp";
		RemoteMethodTimeStamp::meta.isAbstract() = false;
		Timestamp::meta.name() = "Timestamp";
		Timestamp::meta.isAbstract() = true;
		
		vector<string> System_globalClockSkew_dva;
		System::meta_globalClockSkew.name() = "globalClockSkew";
		System::meta_globalClockSkew.type() = "Integer";
		System::meta_globalClockSkew.min() = 1;
		System::meta_globalClockSkew.max() = 1;
		System::meta_globalClockSkew.nonpersistent() = false;
		System::meta_globalClockSkew.ordered() = false;
		System::meta_globalClockSkew.visibility() = "public";
		System::meta_globalClockSkew.defvalue() = System_globalClockSkew_dva;
		vector<string> PreemptionTimeStamp_type_dva;
		PreemptionTimeStamp::meta_type.name() = "type";
		PreemptionTimeStamp::meta_type.type() = "Integer";
		PreemptionTimeStamp::meta_type.min() = 1;
		PreemptionTimeStamp::meta_type.max() = 1;
		PreemptionTimeStamp::meta_type.nonpersistent() = false;
		PreemptionTimeStamp::meta_type.ordered() = false;
		PreemptionTimeStamp::meta_type.visibility() = "public";
		PreemptionTimeStamp::meta_type.defvalue() = PreemptionTimeStamp_type_dva;
		vector<string> Process_processNumber_dva;
		Process::meta_processNumber.name() = "processNumber";
		Process::meta_processNumber.type() = "Integer";
		Process::meta_processNumber.min() = 1;
		Process::meta_processNumber.max() = 1;
		Process::meta_processNumber.nonpersistent() = false;
		Process::meta_processNumber.ordered() = false;
		Process::meta_processNumber.visibility() = "public";
		Process::meta_processNumber.defvalue() = Process_processNumber_dva;
		vector<string> Processor_processorBusSpeed_dva;
		Processor::meta_processorBusSpeed.name() = "processorBusSpeed";
		Processor::meta_processorBusSpeed.type() = "Integer";
		Processor::meta_processorBusSpeed.min() = 1;
		Processor::meta_processorBusSpeed.max() = 1;
		Processor::meta_processorBusSpeed.nonpersistent() = false;
		Processor::meta_processorBusSpeed.ordered() = false;
		Processor::meta_processorBusSpeed.visibility() = "public";
		Processor::meta_processorBusSpeed.defvalue() = Processor_processorBusSpeed_dva;
		vector<string> Processor_processorSpeed_dva;
		Processor::meta_processorSpeed.name() = "processorSpeed";
		Processor::meta_processorSpeed.type() = "Integer";
		Processor::meta_processorSpeed.min() = 1;
		Processor::meta_processorSpeed.max() = 1;
		Processor::meta_processorSpeed.nonpersistent() = false;
		Processor::meta_processorSpeed.ordered() = false;
		Processor::meta_processorSpeed.visibility() = "public";
		Processor::meta_processorSpeed.defvalue() = Processor_processorSpeed_dva;
		vector<string> Processor_processorMemory_dva;
		Processor::meta_processorMemory.name() = "processorMemory";
		Processor::meta_processorMemory.type() = "Integer";
		Processor::meta_processorMemory.min() = 1;
		Processor::meta_processorMemory.max() = 1;
		Processor::meta_processorMemory.nonpersistent() = false;
		Processor::meta_processorMemory.ordered() = false;
		Processor::meta_processorMemory.visibility() = "public";
		Processor::meta_processorMemory.defvalue() = Processor_processorMemory_dva;
		vector<string> Processor_clockRes_dva;
		Processor::meta_clockRes.name() = "clockRes";
		Processor::meta_clockRes.type() = "Integer";
		Processor::meta_clockRes.min() = 1;
		Processor::meta_clockRes.max() = 1;
		Processor::meta_clockRes.nonpersistent() = false;
		Processor::meta_clockRes.ordered() = false;
		Processor::meta_clockRes.visibility() = "public";
		Processor::meta_clockRes.defvalue() = Processor_clockRes_dva;
		vector<string> Network_networkLatency_dva;
		Network::meta_networkLatency.name() = "networkLatency";
		Network::meta_networkLatency.type() = "Integer";
		Network::meta_networkLatency.min() = 1;
		Network::meta_networkLatency.max() = 1;
		Network::meta_networkLatency.nonpersistent() = false;
		Network::meta_networkLatency.ordered() = false;
		Network::meta_networkLatency.visibility() = "public";
		Network::meta_networkLatency.defvalue() = Network_networkLatency_dva;
		vector<string> Network_networkBandwidth_dva;
		Network::meta_networkBandwidth.name() = "networkBandwidth";
		Network::meta_networkBandwidth.type() = "Integer";
		Network::meta_networkBandwidth.min() = 1;
		Network::meta_networkBandwidth.max() = 1;
		Network::meta_networkBandwidth.nonpersistent() = false;
		Network::meta_networkBandwidth.ordered() = false;
		Network::meta_networkBandwidth.visibility() = "public";
		Network::meta_networkBandwidth.defvalue() = Network_networkBandwidth_dva;
		vector<string> OperatingSystem_schedulingPolicyId_dva;
		OperatingSystem::meta_schedulingPolicyId.name() = "schedulingPolicyId";
		OperatingSystem::meta_schedulingPolicyId.type() = "String";
		OperatingSystem::meta_schedulingPolicyId.min() = 1;
		OperatingSystem::meta_schedulingPolicyId.max() = 1;
		OperatingSystem::meta_schedulingPolicyId.nonpersistent() = false;
		OperatingSystem::meta_schedulingPolicyId.ordered() = false;
		OperatingSystem::meta_schedulingPolicyId.visibility() = "public";
		OperatingSystem::meta_schedulingPolicyId.defvalue() = OperatingSystem_schedulingPolicyId_dva;
		vector<string> OperatingSystem_numThreadPriorities_dva;
		OperatingSystem::meta_numThreadPriorities.name() = "numThreadPriorities";
		OperatingSystem::meta_numThreadPriorities.type() = "Integer";
		OperatingSystem::meta_numThreadPriorities.min() = 1;
		OperatingSystem::meta_numThreadPriorities.max() = 1;
		OperatingSystem::meta_numThreadPriorities.nonpersistent() = false;
		OperatingSystem::meta_numThreadPriorities.ordered() = false;
		OperatingSystem::meta_numThreadPriorities.visibility() = "public";
		OperatingSystem::meta_numThreadPriorities.defvalue() = OperatingSystem_numThreadPriorities_dva;
		vector<string> Thread_stackSize_dva;
		Thread::meta_stackSize.name() = "stackSize";
		Thread::meta_stackSize.type() = "Integer";
		Thread::meta_stackSize.min() = 1;
		Thread::meta_stackSize.max() = 1;
		Thread::meta_stackSize.nonpersistent() = false;
		Thread::meta_stackSize.ordered() = false;
		Thread::meta_stackSize.visibility() = "public";
		Thread::meta_stackSize.defvalue() = Thread_stackSize_dva;
		vector<string> Thread_threadPriority_dva;
		Thread::meta_threadPriority.name() = "threadPriority";
		Thread::meta_threadPriority.type() = "Integer";
		Thread::meta_threadPriority.min() = 1;
		Thread::meta_threadPriority.max() = 1;
		Thread::meta_threadPriority.nonpersistent() = false;
		Thread::meta_threadPriority.ordered() = false;
		Thread::meta_threadPriority.visibility() = "public";
		Thread::meta_threadPriority.defvalue() = Thread_threadPriority_dva;
		vector<string> IIFObject_name_dva;
		IIFObject::meta_name.name() = "name";
		IIFObject::meta_name.type() = "String";
		IIFObject::meta_name.min() = 1;
		IIFObject::meta_name.max() = 1;
		IIFObject::meta_name.nonpersistent() = false;
		IIFObject::meta_name.ordered() = false;
		IIFObject::meta_name.visibility() = "public";
		IIFObject::meta_name.defvalue() = IIFObject_name_dva;
		vector<string> Component_GroupId_dva;
		Component::meta_GroupId.name() = "GroupId";
		Component::meta_GroupId.type() = "Integer";
		Component::meta_GroupId.min() = 1;
		Component::meta_GroupId.max() = 1;
		Component::meta_GroupId.nonpersistent() = false;
		Component::meta_GroupId.ordered() = false;
		Component::meta_GroupId.visibility() = "public";
		Component::meta_GroupId.defvalue() = Component_GroupId_dva;
		vector<string> Component_ItemId_dva;
		Component::meta_ItemId.name() = "ItemId";
		Component::meta_ItemId.type() = "Integer";
		Component::meta_ItemId.min() = 1;
		Component::meta_ItemId.max() = 1;
		Component::meta_ItemId.nonpersistent() = false;
		Component::meta_ItemId.ordered() = false;
		Component::meta_ItemId.visibility() = "public";
		Component::meta_ItemId.defvalue() = Component_ItemId_dva;
		vector<string> Component_componentSize_dva;
		Component::meta_componentSize.name() = "componentSize";
		Component::meta_componentSize.type() = "Integer";
		Component::meta_componentSize.min() = 1;
		Component::meta_componentSize.max() = 1;
		Component::meta_componentSize.nonpersistent() = false;
		Component::meta_componentSize.ordered() = false;
		Component::meta_componentSize.visibility() = "public";
		Component::meta_componentSize.defvalue() = Component_componentSize_dva;
		vector<string> DispatchingQueue_dispatchingQueueSize_dva;
		DispatchingQueue::meta_dispatchingQueueSize.name() = "dispatchingQueueSize";
		DispatchingQueue::meta_dispatchingQueueSize.type() = "Integer";
		DispatchingQueue::meta_dispatchingQueueSize.min() = 1;
		DispatchingQueue::meta_dispatchingQueueSize.max() = 1;
		DispatchingQueue::meta_dispatchingQueueSize.nonpersistent() = false;
		DispatchingQueue::meta_dispatchingQueueSize.ordered() = false;
		DispatchingQueue::meta_dispatchingQueueSize.visibility() = "public";
		DispatchingQueue::meta_dispatchingQueueSize.defvalue() = DispatchingQueue_dispatchingQueueSize_dva;
		vector<string> DispatchingQueue_dispatchingQueueId_dva;
		DispatchingQueue::meta_dispatchingQueueId.name() = "dispatchingQueueId";
		DispatchingQueue::meta_dispatchingQueueId.type() = "Integer";
		DispatchingQueue::meta_dispatchingQueueId.min() = 1;
		DispatchingQueue::meta_dispatchingQueueId.max() = 1;
		DispatchingQueue::meta_dispatchingQueueId.nonpersistent() = false;
		DispatchingQueue::meta_dispatchingQueueId.ordered() = false;
		DispatchingQueue::meta_dispatchingQueueId.visibility() = "public";
		DispatchingQueue::meta_dispatchingQueueId.defvalue() = DispatchingQueue_dispatchingQueueId_dva;
		vector<string> SubscribePort_isERM_Subscriber_dva;
		SubscribePort::meta_isERM_Subscriber.name() = "isERM_Subscriber";
		SubscribePort::meta_isERM_Subscriber.type() = "Boolean";
		SubscribePort::meta_isERM_Subscriber.min() = 1;
		SubscribePort::meta_isERM_Subscriber.max() = 1;
		SubscribePort::meta_isERM_Subscriber.nonpersistent() = false;
		SubscribePort::meta_isERM_Subscriber.ordered() = false;
		SubscribePort::meta_isERM_Subscriber.visibility() = "public";
		SubscribePort::meta_isERM_Subscriber.defvalue() = SubscribePort_isERM_Subscriber_dva;
		vector<string> SubscribePort_eventsCorrelated_dva;
		SubscribePort::meta_eventsCorrelated.name() = "eventsCorrelated";
		SubscribePort::meta_eventsCorrelated.type() = "Boolean";
		SubscribePort::meta_eventsCorrelated.min() = 1;
		SubscribePort::meta_eventsCorrelated.max() = 1;
		SubscribePort::meta_eventsCorrelated.nonpersistent() = false;
		SubscribePort::meta_eventsCorrelated.ordered() = false;
		SubscribePort::meta_eventsCorrelated.visibility() = "public";
		SubscribePort::meta_eventsCorrelated.defvalue() = SubscribePort_eventsCorrelated_dva;
		vector<string> Event_eventSourceTypeId_dva;
		Event::meta_eventSourceTypeId.name() = "eventSourceTypeId";
		Event::meta_eventSourceTypeId.type() = "Integer";
		Event::meta_eventSourceTypeId.min() = 1;
		Event::meta_eventSourceTypeId.max() = 1;
		Event::meta_eventSourceTypeId.nonpersistent() = false;
		Event::meta_eventSourceTypeId.ordered() = false;
		Event::meta_eventSourceTypeId.visibility() = "public";
		Event::meta_eventSourceTypeId.defvalue() = Event_eventSourceTypeId_dva;
		vector<string> ComponentMode_mode_dva;
		ComponentMode::meta_mode.name() = "mode";
		ComponentMode::meta_mode.type() = "String";
		ComponentMode::meta_mode.min() = 1;
		ComponentMode::meta_mode.max() = 1;
		ComponentMode::meta_mode.nonpersistent() = false;
		ComponentMode::meta_mode.ordered() = false;
		ComponentMode::meta_mode.visibility() = "public";
		ComponentMode::meta_mode.defvalue() = ComponentMode_mode_dva;
		vector<string> SuppliedEventTimeStamp_type_dva;
		SuppliedEventTimeStamp::meta_type.name() = "type";
		SuppliedEventTimeStamp::meta_type.type() = "Integer";
		SuppliedEventTimeStamp::meta_type.min() = 1;
		SuppliedEventTimeStamp::meta_type.max() = 1;
		SuppliedEventTimeStamp::meta_type.nonpersistent() = false;
		SuppliedEventTimeStamp::meta_type.ordered() = false;
		SuppliedEventTimeStamp::meta_type.visibility() = "public";
		SuppliedEventTimeStamp::meta_type.defvalue() = SuppliedEventTimeStamp_type_dva;
		vector<string> QueueReorderingTimeStamp_type_dva;
		QueueReorderingTimeStamp::meta_type.name() = "type";
		QueueReorderingTimeStamp::meta_type.type() = "Integer";
		QueueReorderingTimeStamp::meta_type.min() = 1;
		QueueReorderingTimeStamp::meta_type.max() = 1;
		QueueReorderingTimeStamp::meta_type.nonpersistent() = false;
		QueueReorderingTimeStamp::meta_type.ordered() = false;
		QueueReorderingTimeStamp::meta_type.visibility() = "public";
		QueueReorderingTimeStamp::meta_type.defvalue() = QueueReorderingTimeStamp_type_dva;
		vector<string> FrameTimeStamp_type_dva;
		FrameTimeStamp::meta_type.name() = "type";
		FrameTimeStamp::meta_type.type() = "Integer";
		FrameTimeStamp::meta_type.min() = 1;
		FrameTimeStamp::meta_type.max() = 1;
		FrameTimeStamp::meta_type.nonpersistent() = false;
		FrameTimeStamp::meta_type.ordered() = false;
		FrameTimeStamp::meta_type.visibility() = "public";
		FrameTimeStamp::meta_type.defvalue() = FrameTimeStamp_type_dva;
		vector<string> ConsumedEventTimeStamp_type_dva;
		ConsumedEventTimeStamp::meta_type.name() = "type";
		ConsumedEventTimeStamp::meta_type.type() = "Integer";
		ConsumedEventTimeStamp::meta_type.min() = 1;
		ConsumedEventTimeStamp::meta_type.max() = 1;
		ConsumedEventTimeStamp::meta_type.nonpersistent() = false;
		ConsumedEventTimeStamp::meta_type.ordered() = false;
		ConsumedEventTimeStamp::meta_type.visibility() = "public";
		ConsumedEventTimeStamp::meta_type.defvalue() = ConsumedEventTimeStamp_type_dva;
		vector<string> RemoteMethodTimeStamp_type_dva;
		RemoteMethodTimeStamp::meta_type.name() = "type";
		RemoteMethodTimeStamp::meta_type.type() = "Integer";
		RemoteMethodTimeStamp::meta_type.min() = 1;
		RemoteMethodTimeStamp::meta_type.max() = 1;
		RemoteMethodTimeStamp::meta_type.nonpersistent() = false;
		RemoteMethodTimeStamp::meta_type.ordered() = false;
		RemoteMethodTimeStamp::meta_type.visibility() = "public";
		RemoteMethodTimeStamp::meta_type.defvalue() = RemoteMethodTimeStamp_type_dva;
		vector<string> Timestamp_timestamp_dva;
		Timestamp::meta_timestamp.name() = "timestamp";
		Timestamp::meta_timestamp.type() = "Integer";
		Timestamp::meta_timestamp.min() = 1;
		Timestamp::meta_timestamp.max() = 1;
		Timestamp::meta_timestamp.nonpersistent() = false;
		Timestamp::meta_timestamp.ordered() = false;
		Timestamp::meta_timestamp.visibility() = "public";
		Timestamp::meta_timestamp.defvalue() = Timestamp_timestamp_dva;
		
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			PreemptionTimeStamp::meta_Thread = Uml::AssociationRole::Create(ass);
			PreemptionTimeStamp::meta_Thread.name() = "Thread";
			PreemptionTimeStamp::meta_Thread.min() = 1;
			PreemptionTimeStamp::meta_Thread.max() = 1;
			PreemptionTimeStamp::meta_Thread.isNavigable() = true;
			PreemptionTimeStamp::meta_Thread.isPrimary() = false;
			PreemptionTimeStamp::meta_Thread.target() = Thread::meta;
			Thread::meta_PreemptionTimeStamp = Uml::AssociationRole::Create(ass);
			Thread::meta_PreemptionTimeStamp.name() = "PreemptionTimeStamp";
			Thread::meta_PreemptionTimeStamp.min() = 0;
			Thread::meta_PreemptionTimeStamp.max() = 1;
			Thread::meta_PreemptionTimeStamp.isNavigable() = true;
			Thread::meta_PreemptionTimeStamp.isPrimary() = false;
			Thread::meta_PreemptionTimeStamp.target() = PreemptionTimeStamp::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Network::meta_Processor = Uml::AssociationRole::Create(ass);
			Network::meta_Processor.name() = "Processor";
			Network::meta_Processor.min() = 0;
			Network::meta_Processor.max() = -1;
			Network::meta_Processor.isNavigable() = true;
			Network::meta_Processor.isPrimary() = false;
			Network::meta_Processor.target() = Processor::meta;
			Processor::meta_Network = Uml::AssociationRole::Create(ass);
			Processor::meta_Network.name() = "Network";
			Processor::meta_Network.min() = 0;
			Processor::meta_Network.max() = -1;
			Processor::meta_Network.isNavigable() = true;
			Processor::meta_Network.isPrimary() = false;
			Processor::meta_Network.target() = Network::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Thread::meta_ThreadedTimeStamp = Uml::AssociationRole::Create(ass);
			Thread::meta_ThreadedTimeStamp.name() = "ThreadedTimeStamp";
			Thread::meta_ThreadedTimeStamp.min() = 0;
			Thread::meta_ThreadedTimeStamp.max() = -1;
			Thread::meta_ThreadedTimeStamp.isNavigable() = true;
			Thread::meta_ThreadedTimeStamp.isPrimary() = false;
			Thread::meta_ThreadedTimeStamp.target() = ThreadedTimeStamp::meta;
			ThreadedTimeStamp::meta_thread = Uml::AssociationRole::Create(ass);
			ThreadedTimeStamp::meta_thread.name() = "thread";
			ThreadedTimeStamp::meta_thread.min() = 1;
			ThreadedTimeStamp::meta_thread.max() = 1;
			ThreadedTimeStamp::meta_thread.isNavigable() = true;
			ThreadedTimeStamp::meta_thread.isPrimary() = false;
			ThreadedTimeStamp::meta_thread.target() = Thread::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Thread::meta_DispatchingQueue = Uml::AssociationRole::Create(ass);
			Thread::meta_DispatchingQueue.name() = "DispatchingQueue";
			Thread::meta_DispatchingQueue.min() = 0;
			Thread::meta_DispatchingQueue.max() = 1;
			Thread::meta_DispatchingQueue.isNavigable() = true;
			Thread::meta_DispatchingQueue.isPrimary() = false;
			Thread::meta_DispatchingQueue.target() = DispatchingQueue::meta;
			DispatchingQueue::meta_servicedBy = Uml::AssociationRole::Create(ass);
			DispatchingQueue::meta_servicedBy.name() = "servicedBy";
			DispatchingQueue::meta_servicedBy.min() = 1;
			DispatchingQueue::meta_servicedBy.max() = -1;
			DispatchingQueue::meta_servicedBy.isNavigable() = true;
			DispatchingQueue::meta_servicedBy.isPrimary() = false;
			DispatchingQueue::meta_servicedBy.target() = Thread::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Schedule::meta_Component = Uml::AssociationRole::Create(ass);
			Schedule::meta_Component.name() = "Component";
			Schedule::meta_Component.min() = 0;
			Schedule::meta_Component.max() = -1;
			Schedule::meta_Component.isNavigable() = true;
			Schedule::meta_Component.isPrimary() = false;
			Schedule::meta_Component.target() = Component::meta;
			Component::meta_Schedule = Uml::AssociationRole::Create(ass);
			Component::meta_Schedule.name() = "Schedule";
			Component::meta_Schedule.min() = 1;
			Component::meta_Schedule.max() = 1;
			Component::meta_Schedule.isNavigable() = true;
			Component::meta_Schedule.isPrimary() = false;
			Component::meta_Schedule.target() = Schedule::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Schedule::meta_dispatchingQueue = Uml::AssociationRole::Create(ass);
			Schedule::meta_dispatchingQueue.name() = "dispatchingQueue";
			Schedule::meta_dispatchingQueue.min() = 1;
			Schedule::meta_dispatchingQueue.max() = -1;
			Schedule::meta_dispatchingQueue.isNavigable() = true;
			Schedule::meta_dispatchingQueue.isPrimary() = false;
			Schedule::meta_dispatchingQueue.target() = DispatchingQueue::meta;
			DispatchingQueue::meta_Schedule = Uml::AssociationRole::Create(ass);
			DispatchingQueue::meta_Schedule.name() = "Schedule";
			DispatchingQueue::meta_Schedule.min() = 0;
			DispatchingQueue::meta_Schedule.max() = 1;
			DispatchingQueue::meta_Schedule.isNavigable() = true;
			DispatchingQueue::meta_Schedule.isPrimary() = false;
			DispatchingQueue::meta_Schedule.target() = Schedule::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Component::meta_ComponentMode = Uml::AssociationRole::Create(ass);
			Component::meta_ComponentMode.name() = "ComponentMode";
			Component::meta_ComponentMode.min() = 0;
			Component::meta_ComponentMode.max() = 1;
			Component::meta_ComponentMode.isNavigable() = true;
			Component::meta_ComponentMode.isPrimary() = false;
			Component::meta_ComponentMode.target() = ComponentMode::meta;
			ComponentMode::meta_Component = Uml::AssociationRole::Create(ass);
			ComponentMode::meta_Component.name() = "Component";
			ComponentMode::meta_Component.min() = 1;
			ComponentMode::meta_Component.max() = 1;
			ComponentMode::meta_Component.isNavigable() = true;
			ComponentMode::meta_Component.isPrimary() = false;
			ComponentMode::meta_Component.target() = Component::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			EventChannel::meta_Scheduler = Uml::AssociationRole::Create(ass);
			EventChannel::meta_Scheduler.name() = "Scheduler";
			EventChannel::meta_Scheduler.min() = 1;
			EventChannel::meta_Scheduler.max() = 1;
			EventChannel::meta_Scheduler.isNavigable() = true;
			EventChannel::meta_Scheduler.isPrimary() = false;
			EventChannel::meta_Scheduler.target() = Scheduler::meta;
			Scheduler::meta_EventChannel = Uml::AssociationRole::Create(ass);
			Scheduler::meta_EventChannel.name() = "EventChannel";
			Scheduler::meta_EventChannel.min() = 1;
			Scheduler::meta_EventChannel.max() = 1;
			Scheduler::meta_EventChannel.isNavigable() = true;
			Scheduler::meta_EventChannel.isPrimary() = false;
			Scheduler::meta_EventChannel.target() = EventChannel::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Timer::meta_rate = Uml::AssociationRole::Create(ass);
			Timer::meta_rate.name() = "rate";
			Timer::meta_rate.min() = 1;
			Timer::meta_rate.max() = 1;
			Timer::meta_rate.isNavigable() = true;
			Timer::meta_rate.isPrimary() = false;
			Timer::meta_rate.target() = Rate::meta;
			Rate::meta_Timer = Uml::AssociationRole::Create(ass);
			Rate::meta_Timer.name() = "Timer";
			Rate::meta_Timer.min() = 0;
			Rate::meta_Timer.max() = -1;
			Rate::meta_Timer.isNavigable() = true;
			Rate::meta_Timer.isPrimary() = false;
			Rate::meta_Timer.target() = Timer::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			DispatchingQueue::meta_QueueReorderingTimeStamp = Uml::AssociationRole::Create(ass);
			DispatchingQueue::meta_QueueReorderingTimeStamp.name() = "QueueReorderingTimeStamp";
			DispatchingQueue::meta_QueueReorderingTimeStamp.min() = 0;
			DispatchingQueue::meta_QueueReorderingTimeStamp.max() = -1;
			DispatchingQueue::meta_QueueReorderingTimeStamp.isNavigable() = true;
			DispatchingQueue::meta_QueueReorderingTimeStamp.isPrimary() = false;
			DispatchingQueue::meta_QueueReorderingTimeStamp.target() = QueueReorderingTimeStamp::meta;
			QueueReorderingTimeStamp::meta_DispatchingQueue = Uml::AssociationRole::Create(ass);
			QueueReorderingTimeStamp::meta_DispatchingQueue.name() = "DispatchingQueue";
			QueueReorderingTimeStamp::meta_DispatchingQueue.min() = 1;
			QueueReorderingTimeStamp::meta_DispatchingQueue.max() = 1;
			QueueReorderingTimeStamp::meta_DispatchingQueue.isNavigable() = true;
			QueueReorderingTimeStamp::meta_DispatchingQueue.isPrimary() = false;
			QueueReorderingTimeStamp::meta_DispatchingQueue.target() = DispatchingQueue::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Rate::meta_FrameTimeStamp = Uml::AssociationRole::Create(ass);
			Rate::meta_FrameTimeStamp.name() = "FrameTimeStamp";
			Rate::meta_FrameTimeStamp.min() = 0;
			Rate::meta_FrameTimeStamp.max() = -1;
			Rate::meta_FrameTimeStamp.isNavigable() = true;
			Rate::meta_FrameTimeStamp.isPrimary() = false;
			Rate::meta_FrameTimeStamp.target() = FrameTimeStamp::meta;
			FrameTimeStamp::meta_Rate = Uml::AssociationRole::Create(ass);
			FrameTimeStamp::meta_Rate.name() = "Rate";
			FrameTimeStamp::meta_Rate.min() = 1;
			FrameTimeStamp::meta_Rate.max() = 1;
			FrameTimeStamp::meta_Rate.isNavigable() = true;
			FrameTimeStamp::meta_Rate.isPrimary() = false;
			FrameTimeStamp::meta_Rate.target() = Rate::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			PublishPort::meta_ConsumedEventTimeStamp = Uml::AssociationRole::Create(ass);
			PublishPort::meta_ConsumedEventTimeStamp.name() = "ConsumedEventTimeStamp";
			PublishPort::meta_ConsumedEventTimeStamp.min() = 0;
			PublishPort::meta_ConsumedEventTimeStamp.max() = -1;
			PublishPort::meta_ConsumedEventTimeStamp.isNavigable() = true;
			PublishPort::meta_ConsumedEventTimeStamp.isPrimary() = false;
			PublishPort::meta_ConsumedEventTimeStamp.target() = ConsumedEventTimeStamp::meta;
			ConsumedEventTimeStamp::meta_PublishPort = Uml::AssociationRole::Create(ass);
			ConsumedEventTimeStamp::meta_PublishPort.name() = "PublishPort";
			ConsumedEventTimeStamp::meta_PublishPort.min() = 1;
			ConsumedEventTimeStamp::meta_PublishPort.max() = 1;
			ConsumedEventTimeStamp::meta_PublishPort.isNavigable() = true;
			ConsumedEventTimeStamp::meta_PublishPort.isPrimary() = false;
			ConsumedEventTimeStamp::meta_PublishPort.target() = PublishPort::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			PublishPort::meta_SuppliedEventTimeStamp = Uml::AssociationRole::Create(ass);
			PublishPort::meta_SuppliedEventTimeStamp.name() = "SuppliedEventTimeStamp";
			PublishPort::meta_SuppliedEventTimeStamp.min() = 0;
			PublishPort::meta_SuppliedEventTimeStamp.max() = -1;
			PublishPort::meta_SuppliedEventTimeStamp.isNavigable() = true;
			PublishPort::meta_SuppliedEventTimeStamp.isPrimary() = false;
			PublishPort::meta_SuppliedEventTimeStamp.target() = SuppliedEventTimeStamp::meta;
			SuppliedEventTimeStamp::meta_PublishPort = Uml::AssociationRole::Create(ass);
			SuppliedEventTimeStamp::meta_PublishPort.name() = "PublishPort";
			SuppliedEventTimeStamp::meta_PublishPort.min() = 1;
			SuppliedEventTimeStamp::meta_PublishPort.max() = 1;
			SuppliedEventTimeStamp::meta_PublishPort.isNavigable() = true;
			SuppliedEventTimeStamp::meta_PublishPort.isPrimary() = false;
			SuppliedEventTimeStamp::meta_PublishPort.target() = PublishPort::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			SubscribePort::meta_ConsumedEventTimeStamp = Uml::AssociationRole::Create(ass);
			SubscribePort::meta_ConsumedEventTimeStamp.name() = "ConsumedEventTimeStamp";
			SubscribePort::meta_ConsumedEventTimeStamp.min() = 0;
			SubscribePort::meta_ConsumedEventTimeStamp.max() = -1;
			SubscribePort::meta_ConsumedEventTimeStamp.isNavigable() = true;
			SubscribePort::meta_ConsumedEventTimeStamp.isPrimary() = false;
			SubscribePort::meta_ConsumedEventTimeStamp.target() = ConsumedEventTimeStamp::meta;
			ConsumedEventTimeStamp::meta_SubscribePort = Uml::AssociationRole::Create(ass);
			ConsumedEventTimeStamp::meta_SubscribePort.name() = "SubscribePort";
			ConsumedEventTimeStamp::meta_SubscribePort.min() = 1;
			ConsumedEventTimeStamp::meta_SubscribePort.max() = 1;
			ConsumedEventTimeStamp::meta_SubscribePort.isNavigable() = true;
			ConsumedEventTimeStamp::meta_SubscribePort.isPrimary() = false;
			ConsumedEventTimeStamp::meta_SubscribePort.target() = SubscribePort::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			SubscribePort::meta_EventDependencyTimeStamp = Uml::AssociationRole::Create(ass);
			SubscribePort::meta_EventDependencyTimeStamp.name() = "EventDependencyTimeStamp";
			SubscribePort::meta_EventDependencyTimeStamp.min() = 0;
			SubscribePort::meta_EventDependencyTimeStamp.max() = -1;
			SubscribePort::meta_EventDependencyTimeStamp.isNavigable() = true;
			SubscribePort::meta_EventDependencyTimeStamp.isPrimary() = false;
			SubscribePort::meta_EventDependencyTimeStamp.target() = EventDependencyTimeStamp::meta;
			EventDependencyTimeStamp::meta_SubscribePort = Uml::AssociationRole::Create(ass);
			EventDependencyTimeStamp::meta_SubscribePort.name() = "SubscribePort";
			EventDependencyTimeStamp::meta_SubscribePort.min() = 1;
			EventDependencyTimeStamp::meta_SubscribePort.max() = 1;
			EventDependencyTimeStamp::meta_SubscribePort.isNavigable() = true;
			EventDependencyTimeStamp::meta_SubscribePort.isPrimary() = false;
			EventDependencyTimeStamp::meta_SubscribePort.target() = SubscribePort::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Event::meta_eventtimestamp = Uml::AssociationRole::Create(ass);
			Event::meta_eventtimestamp.name() = "eventtimestamp";
			Event::meta_eventtimestamp.min() = 0;
			Event::meta_eventtimestamp.max() = -1;
			Event::meta_eventtimestamp.isNavigable() = true;
			Event::meta_eventtimestamp.isPrimary() = false;
			Event::meta_eventtimestamp.target() = EventDependencyTimeStamp::meta;
			EventDependencyTimeStamp::meta_incomingEvent = Uml::AssociationRole::Create(ass);
			EventDependencyTimeStamp::meta_incomingEvent.name() = "incomingEvent";
			EventDependencyTimeStamp::meta_incomingEvent.min() = 1;
			EventDependencyTimeStamp::meta_incomingEvent.max() = 1;
			EventDependencyTimeStamp::meta_incomingEvent.isNavigable() = true;
			EventDependencyTimeStamp::meta_incomingEvent.isPrimary() = false;
			EventDependencyTimeStamp::meta_incomingEvent.target() = Event::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Event::meta_eventtimestamps = Uml::AssociationRole::Create(ass);
			Event::meta_eventtimestamps.name() = "eventtimestamps";
			Event::meta_eventtimestamps.min() = 0;
			Event::meta_eventtimestamps.max() = -1;
			Event::meta_eventtimestamps.isNavigable() = true;
			Event::meta_eventtimestamps.isPrimary() = false;
			Event::meta_eventtimestamps.target() = EventDependencyTimeStamp::meta;
			EventDependencyTimeStamp::meta_outgoingEvents = Uml::AssociationRole::Create(ass);
			EventDependencyTimeStamp::meta_outgoingEvents.name() = "outgoingEvents";
			EventDependencyTimeStamp::meta_outgoingEvents.min() = 0;
			EventDependencyTimeStamp::meta_outgoingEvents.max() = -1;
			EventDependencyTimeStamp::meta_outgoingEvents.isNavigable() = true;
			EventDependencyTimeStamp::meta_outgoingEvents.isPrimary() = false;
			EventDependencyTimeStamp::meta_outgoingEvents.target() = Event::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Event::meta_SuppliedEventTimeStamp = Uml::AssociationRole::Create(ass);
			Event::meta_SuppliedEventTimeStamp.name() = "SuppliedEventTimeStamp";
			Event::meta_SuppliedEventTimeStamp.min() = 0;
			Event::meta_SuppliedEventTimeStamp.max() = -1;
			Event::meta_SuppliedEventTimeStamp.isNavigable() = true;
			Event::meta_SuppliedEventTimeStamp.isPrimary() = false;
			Event::meta_SuppliedEventTimeStamp.target() = SuppliedEventTimeStamp::meta;
			SuppliedEventTimeStamp::meta_Event = Uml::AssociationRole::Create(ass);
			SuppliedEventTimeStamp::meta_Event.name() = "Event";
			SuppliedEventTimeStamp::meta_Event.min() = 1;
			SuppliedEventTimeStamp::meta_Event.max() = 1;
			SuppliedEventTimeStamp::meta_Event.isNavigable() = true;
			SuppliedEventTimeStamp::meta_Event.isPrimary() = false;
			SuppliedEventTimeStamp::meta_Event.target() = Event::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Event::meta_ConsumedEventTimeStamp = Uml::AssociationRole::Create(ass);
			Event::meta_ConsumedEventTimeStamp.name() = "ConsumedEventTimeStamp";
			Event::meta_ConsumedEventTimeStamp.min() = 0;
			Event::meta_ConsumedEventTimeStamp.max() = -1;
			Event::meta_ConsumedEventTimeStamp.isNavigable() = true;
			Event::meta_ConsumedEventTimeStamp.isPrimary() = false;
			Event::meta_ConsumedEventTimeStamp.target() = ConsumedEventTimeStamp::meta;
			ConsumedEventTimeStamp::meta_Event = Uml::AssociationRole::Create(ass);
			ConsumedEventTimeStamp::meta_Event.name() = "Event";
			ConsumedEventTimeStamp::meta_Event.min() = 1;
			ConsumedEventTimeStamp::meta_Event.max() = 1;
			ConsumedEventTimeStamp::meta_Event.isNavigable() = true;
			ConsumedEventTimeStamp::meta_Event.isPrimary() = false;
			ConsumedEventTimeStamp::meta_Event.target() = Event::meta;
		}
		{
			Uml::Association ass = Uml::Association::Create(umldiagram);
			Action::meta_RemoteMethodTimeStamp = Uml::AssociationRole::Create(ass);
			Action::meta_RemoteMethodTimeStamp.name() = "RemoteMethodTimeStamp";
			Action::meta_RemoteMethodTimeStamp.min() = 0;
			Action::meta_RemoteMethodTimeStamp.max() = -1;
			Action::meta_RemoteMethodTimeStamp.isNavigable() = true;
			Action::meta_RemoteMethodTimeStamp.isPrimary() = false;
			Action::meta_RemoteMethodTimeStamp.target() = RemoteMethodTimeStamp::meta;
			RemoteMethodTimeStamp::meta_Action = Uml::AssociationRole::Create(ass);
			RemoteMethodTimeStamp::meta_Action.name() = "Action";
			RemoteMethodTimeStamp::meta_Action.min() = 1;
			RemoteMethodTimeStamp::meta_Action.max() = 1;
			RemoteMethodTimeStamp::meta_Action.isNavigable() = true;
			RemoteMethodTimeStamp::meta_Action.isPrimary() = false;
			RemoteMethodTimeStamp::meta_Action.target() = Action::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Timestamp::meta_System_parent = Uml::CompositionParentRole::Create(comp);
			Timestamp::meta_System_parent.name() = "System_parent";
			Timestamp::meta_System_parent.isNavigable() = true;
			Timestamp::meta_System_parent.target() = System::meta;
			System::meta_Timestamp_children = Uml::CompositionChildRole::Create(comp);
			System::meta_Timestamp_children.name() = "Timestamp";
			System::meta_Timestamp_children.min() = 0;
			System::meta_Timestamp_children.max() = -1;
			System::meta_Timestamp_children.isNavigable() = true;
			System::meta_Timestamp_children.target() = Timestamp::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Network::meta_System_parent = Uml::CompositionParentRole::Create(comp);
			Network::meta_System_parent.name() = "System_parent";
			Network::meta_System_parent.isNavigable() = true;
			Network::meta_System_parent.target() = System::meta;
			System::meta_Network_children = Uml::CompositionChildRole::Create(comp);
			System::meta_Network_children.name() = "Network";
			System::meta_Network_children.min() = 0;
			System::meta_Network_children.max() = -1;
			System::meta_Network_children.isNavigable() = true;
			System::meta_Network_children.target() = Network::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Processor::meta_System_parent = Uml::CompositionParentRole::Create(comp);
			Processor::meta_System_parent.name() = "System_parent";
			Processor::meta_System_parent.isNavigable() = true;
			Processor::meta_System_parent.target() = System::meta;
			System::meta_Processor_children = Uml::CompositionChildRole::Create(comp);
			System::meta_Processor_children.name() = "Processor";
			System::meta_Processor_children.min() = 1;
			System::meta_Processor_children.max() = -1;
			System::meta_Processor_children.isNavigable() = true;
			System::meta_Processor_children.target() = Processor::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			EventChannel::meta_Process_parent = Uml::CompositionParentRole::Create(comp);
			EventChannel::meta_Process_parent.name() = "Process_parent";
			EventChannel::meta_Process_parent.isNavigable() = true;
			EventChannel::meta_Process_parent.target() = Process::meta;
			Process::meta_EventChannel_child = Uml::CompositionChildRole::Create(comp);
			Process::meta_EventChannel_child.name() = "EventChannel";
			Process::meta_EventChannel_child.min() = 1;
			Process::meta_EventChannel_child.max() = 1;
			Process::meta_EventChannel_child.isNavigable() = true;
			Process::meta_EventChannel_child.target() = EventChannel::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Thread::meta_Process_parent = Uml::CompositionParentRole::Create(comp);
			Thread::meta_Process_parent.name() = "Process_parent";
			Thread::meta_Process_parent.isNavigable() = true;
			Thread::meta_Process_parent.target() = Process::meta;
			Process::meta_Thread_children = Uml::CompositionChildRole::Create(comp);
			Process::meta_Thread_children.name() = "Thread";
			Process::meta_Thread_children.min() = 0;
			Process::meta_Thread_children.max() = -1;
			Process::meta_Thread_children.isNavigable() = true;
			Process::meta_Thread_children.target() = Thread::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Scheduler::meta_Process_parent = Uml::CompositionParentRole::Create(comp);
			Scheduler::meta_Process_parent.name() = "Process_parent";
			Scheduler::meta_Process_parent.isNavigable() = true;
			Scheduler::meta_Process_parent.target() = Process::meta;
			Process::meta_Scheduler_child = Uml::CompositionChildRole::Create(comp);
			Process::meta_Scheduler_child.name() = "Scheduler";
			Process::meta_Scheduler_child.min() = 1;
			Process::meta_Scheduler_child.max() = 1;
			Process::meta_Scheduler_child.isNavigable() = true;
			Process::meta_Scheduler_child.target() = Scheduler::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Component::meta_owner = Uml::CompositionParentRole::Create(comp);
			Component::meta_owner.name() = "owner";
			Component::meta_owner.isNavigable() = true;
			Component::meta_owner.target() = Process::meta;
			Process::meta_Component_children = Uml::CompositionChildRole::Create(comp);
			Process::meta_Component_children.name() = "Component";
			Process::meta_Component_children.min() = 0;
			Process::meta_Component_children.max() = -1;
			Process::meta_Component_children.isNavigable() = true;
			Process::meta_Component_children.target() = Component::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			FrameController::meta_Process_parent = Uml::CompositionParentRole::Create(comp);
			FrameController::meta_Process_parent.name() = "Process_parent";
			FrameController::meta_Process_parent.isNavigable() = true;
			FrameController::meta_Process_parent.target() = Process::meta;
			Process::meta_FrameController_child = Uml::CompositionChildRole::Create(comp);
			Process::meta_FrameController_child.name() = "FrameController";
			Process::meta_FrameController_child.min() = 1;
			Process::meta_FrameController_child.max() = 1;
			Process::meta_FrameController_child.isNavigable() = true;
			Process::meta_FrameController_child.target() = FrameController::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			TimeService::meta_Process_parent = Uml::CompositionParentRole::Create(comp);
			TimeService::meta_Process_parent.name() = "Process_parent";
			TimeService::meta_Process_parent.isNavigable() = true;
			TimeService::meta_Process_parent.target() = Process::meta;
			Process::meta_TimeService_child = Uml::CompositionChildRole::Create(comp);
			Process::meta_TimeService_child.name() = "TimeService";
			Process::meta_TimeService_child.min() = 1;
			Process::meta_TimeService_child.max() = 1;
			Process::meta_TimeService_child.isNavigable() = true;
			Process::meta_TimeService_child.target() = TimeService::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			PersistenceService::meta_Process_parent = Uml::CompositionParentRole::Create(comp);
			PersistenceService::meta_Process_parent.name() = "Process_parent";
			PersistenceService::meta_Process_parent.isNavigable() = true;
			PersistenceService::meta_Process_parent.target() = Process::meta;
			Process::meta_PersistenceService_child = Uml::CompositionChildRole::Create(comp);
			Process::meta_PersistenceService_child.name() = "PersistenceService";
			Process::meta_PersistenceService_child.min() = 1;
			Process::meta_PersistenceService_child.max() = 1;
			Process::meta_PersistenceService_child.isNavigable() = true;
			Process::meta_PersistenceService_child.target() = PersistenceService::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Process::meta_Processor_parent = Uml::CompositionParentRole::Create(comp);
			Process::meta_Processor_parent.name() = "Processor_parent";
			Process::meta_Processor_parent.isNavigable() = true;
			Process::meta_Processor_parent.target() = Processor::meta;
			Processor::meta_Process_children = Uml::CompositionChildRole::Create(comp);
			Processor::meta_Process_children.name() = "Process";
			Processor::meta_Process_children.min() = 1;
			Processor::meta_Process_children.max() = -1;
			Processor::meta_Process_children.isNavigable() = true;
			Processor::meta_Process_children.target() = Process::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			OperatingSystem::meta_Processor_parent = Uml::CompositionParentRole::Create(comp);
			OperatingSystem::meta_Processor_parent.name() = "Processor_parent";
			OperatingSystem::meta_Processor_parent.isNavigable() = true;
			OperatingSystem::meta_Processor_parent.target() = Processor::meta;
			Processor::meta_OperatingSystem_child = Uml::CompositionChildRole::Create(comp);
			Processor::meta_OperatingSystem_child.name() = "OperatingSystem";
			Processor::meta_OperatingSystem_child.min() = 1;
			Processor::meta_OperatingSystem_child.max() = 1;
			Processor::meta_OperatingSystem_child.isNavigable() = true;
			Processor::meta_OperatingSystem_child.target() = OperatingSystem::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Rate::meta_Thread_parent = Uml::CompositionParentRole::Create(comp);
			Rate::meta_Thread_parent.name() = "Thread_parent";
			Rate::meta_Thread_parent.isNavigable() = true;
			Rate::meta_Thread_parent.target() = Thread::meta;
			Thread::meta_Rate_child = Uml::CompositionChildRole::Create(comp);
			Thread::meta_Rate_child.name() = "Rate";
			Thread::meta_Rate_child.min() = 1;
			Thread::meta_Rate_child.max() = 1;
			Thread::meta_Rate_child.isNavigable() = true;
			Thread::meta_Rate_child.target() = Rate::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			EventPort::meta_FrameController_parent = Uml::CompositionParentRole::Create(comp);
			EventPort::meta_FrameController_parent.name() = "FrameController_parent";
			EventPort::meta_FrameController_parent.isNavigable() = true;
			EventPort::meta_FrameController_parent.target() = FrameController::meta;
			FrameController::meta_EventPort_children = Uml::CompositionChildRole::Create(comp);
			FrameController::meta_EventPort_children.name() = "EventPort";
			FrameController::meta_EventPort_children.min() = 1;
			FrameController::meta_EventPort_children.max() = -1;
			FrameController::meta_EventPort_children.isNavigable() = true;
			FrameController::meta_EventPort_children.target() = EventPort::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			EventPort::meta_TimeService_parent = Uml::CompositionParentRole::Create(comp);
			EventPort::meta_TimeService_parent.name() = "TimeService_parent";
			EventPort::meta_TimeService_parent.isNavigable() = true;
			EventPort::meta_TimeService_parent.target() = TimeService::meta;
			TimeService::meta_EventPort_children = Uml::CompositionChildRole::Create(comp);
			TimeService::meta_EventPort_children.name() = "EventPort";
			TimeService::meta_EventPort_children.min() = 1;
			TimeService::meta_EventPort_children.max() = -1;
			TimeService::meta_EventPort_children.isNavigable() = true;
			TimeService::meta_EventPort_children.target() = EventPort::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			EventPort::meta_PersistenceService_parent = Uml::CompositionParentRole::Create(comp);
			EventPort::meta_PersistenceService_parent.name() = "PersistenceService_parent";
			EventPort::meta_PersistenceService_parent.isNavigable() = true;
			EventPort::meta_PersistenceService_parent.target() = PersistenceService::meta;
			PersistenceService::meta_EventPort_children = Uml::CompositionChildRole::Create(comp);
			PersistenceService::meta_EventPort_children.name() = "EventPort";
			PersistenceService::meta_EventPort_children.min() = 1;
			PersistenceService::meta_EventPort_children.max() = -1;
			PersistenceService::meta_EventPort_children.isNavigable() = true;
			PersistenceService::meta_EventPort_children.target() = EventPort::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Schedule::meta_Scheduler_parent = Uml::CompositionParentRole::Create(comp);
			Schedule::meta_Scheduler_parent.name() = "Scheduler_parent";
			Schedule::meta_Scheduler_parent.isNavigable() = true;
			Schedule::meta_Scheduler_parent.target() = Scheduler::meta;
			Scheduler::meta_Schedule_children = Uml::CompositionChildRole::Create(comp);
			Scheduler::meta_Schedule_children.name() = "Schedule";
			Scheduler::meta_Schedule_children.min() = 0;
			Scheduler::meta_Schedule_children.max() = -1;
			Scheduler::meta_Schedule_children.isNavigable() = true;
			Scheduler::meta_Schedule_children.target() = Schedule::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Action::meta_Component_parent = Uml::CompositionParentRole::Create(comp);
			Action::meta_Component_parent.name() = "Component_parent";
			Action::meta_Component_parent.isNavigable() = true;
			Action::meta_Component_parent.target() = Component::meta;
			Component::meta_Action_children = Uml::CompositionChildRole::Create(comp);
			Component::meta_Action_children.name() = "Action";
			Component::meta_Action_children.min() = 0;
			Component::meta_Action_children.max() = -1;
			Component::meta_Action_children.isNavigable() = true;
			Component::meta_Action_children.target() = Action::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			EventPort::meta_Component_parent = Uml::CompositionParentRole::Create(comp);
			EventPort::meta_Component_parent.name() = "Component_parent";
			EventPort::meta_Component_parent.isNavigable() = true;
			EventPort::meta_Component_parent.target() = Component::meta;
			Component::meta_EventPort_children = Uml::CompositionChildRole::Create(comp);
			Component::meta_EventPort_children.name() = "EventPort";
			Component::meta_EventPort_children.min() = 0;
			Component::meta_EventPort_children.max() = -1;
			Component::meta_EventPort_children.isNavigable() = true;
			Component::meta_EventPort_children.target() = EventPort::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			DispatchingQueue::meta_EventChannel_parent = Uml::CompositionParentRole::Create(comp);
			DispatchingQueue::meta_EventChannel_parent.name() = "EventChannel_parent";
			DispatchingQueue::meta_EventChannel_parent.isNavigable() = true;
			DispatchingQueue::meta_EventChannel_parent.target() = EventChannel::meta;
			EventChannel::meta_DispatchingQueue_children = Uml::CompositionChildRole::Create(comp);
			EventChannel::meta_DispatchingQueue_children.name() = "DispatchingQueue";
			EventChannel::meta_DispatchingQueue_children.min() = 1;
			EventChannel::meta_DispatchingQueue_children.max() = -1;
			EventChannel::meta_DispatchingQueue_children.isNavigable() = true;
			EventChannel::meta_DispatchingQueue_children.target() = DispatchingQueue::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Timer::meta_EventChannel_parent = Uml::CompositionParentRole::Create(comp);
			Timer::meta_EventChannel_parent.name() = "EventChannel_parent";
			Timer::meta_EventChannel_parent.isNavigable() = true;
			Timer::meta_EventChannel_parent.target() = EventChannel::meta;
			EventChannel::meta_Timer_children = Uml::CompositionChildRole::Create(comp);
			EventChannel::meta_Timer_children.name() = "Timer";
			EventChannel::meta_Timer_children.min() = 0;
			EventChannel::meta_Timer_children.max() = -1;
			EventChannel::meta_Timer_children.isNavigable() = true;
			EventChannel::meta_Timer_children.target() = Timer::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			PublishPort::meta_Timer_parent = Uml::CompositionParentRole::Create(comp);
			PublishPort::meta_Timer_parent.name() = "Timer_parent";
			PublishPort::meta_Timer_parent.isNavigable() = true;
			PublishPort::meta_Timer_parent.target() = Timer::meta;
			Timer::meta_PublishPort_children = Uml::CompositionChildRole::Create(comp);
			Timer::meta_PublishPort_children.name() = "PublishPort";
			Timer::meta_PublishPort_children.min() = 1;
			Timer::meta_PublishPort_children.max() = -1;
			Timer::meta_PublishPort_children.isNavigable() = true;
			Timer::meta_PublishPort_children.target() = PublishPort::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			Event::meta_PublishPort_parent = Uml::CompositionParentRole::Create(comp);
			Event::meta_PublishPort_parent.name() = "PublishPort_parent";
			Event::meta_PublishPort_parent.isNavigable() = true;
			Event::meta_PublishPort_parent.target() = PublishPort::meta;
			PublishPort::meta_Event_children = Uml::CompositionChildRole::Create(comp);
			PublishPort::meta_Event_children.name() = "Event";
			PublishPort::meta_Event_children.min() = 1;
			PublishPort::meta_Event_children.max() = -1;
			PublishPort::meta_Event_children.isNavigable() = true;
			PublishPort::meta_Event_children.target() = Event::meta;
		}
		{
			Uml::Composition comp = Uml::Composition::Create(umldiagram);
			comp.nonpersistent() =false;
		
			ComponentMode::meta_frameModes_ModeTimeStamp_parent = Uml::CompositionParentRole::Create(comp);
			ComponentMode::meta_frameModes_ModeTimeStamp_parent.name() = "frameModes_ModeTimeStamp_parent";
			ComponentMode::meta_frameModes_ModeTimeStamp_parent.isNavigable() = true;
			ComponentMode::meta_frameModes_ModeTimeStamp_parent.target() = ModeTimeStamp::meta;
			ModeTimeStamp::meta_frameModes = Uml::CompositionChildRole::Create(comp);
			ModeTimeStamp::meta_frameModes.name() = "frameModes";
			ModeTimeStamp::meta_frameModes.min() = 0;
			ModeTimeStamp::meta_frameModes.max() = -1;
			ModeTimeStamp::meta_frameModes.isNavigable() = true;
			ModeTimeStamp::meta_frameModes.target() = ComponentMode::meta;
		}
		IIFObject::meta.subTypes() +=  Process::meta;
		IIFObject::meta.subTypes() +=  Processor::meta;
		IIFObject::meta.subTypes() +=  Network::meta;
		IIFObject::meta.subTypes() +=  OperatingSystem::meta;
		IIFObject::meta.subTypes() +=  Thread::meta;
		IIFObject::meta.subTypes() +=  FrameController::meta;
		IIFObject::meta.subTypes() +=  TimeService::meta;
		IIFObject::meta.subTypes() +=  PersistenceService::meta;
		IIFObject::meta.subTypes() +=  Schedule::meta;
		IIFObject::meta.subTypes() +=  Component::meta;
		IIFObject::meta.subTypes() +=  EventPort::meta;
		IIFObject::meta.subTypes() +=  EventChannel::meta;
		IIFObject::meta.subTypes() +=  Scheduler::meta;
		IIFObject::meta.subTypes() +=  Timer::meta;
		IIFObject::meta.subTypes() +=  DispatchingQueue::meta;
		IIFObject::meta.subTypes() +=  Rate::meta;
		IIFObject::meta.subTypes() +=  Event::meta;
		IIFObject::meta.subTypes() +=  Action::meta;
		EventPort::meta.subTypes() +=  PublishPort::meta;
		EventPort::meta.subTypes() +=  SubscribePort::meta;
		ThreadedTimeStamp::meta.subTypes() +=  EventDependencyTimeStamp::meta;
		ThreadedTimeStamp::meta.subTypes() +=  SuppliedEventTimeStamp::meta;
		ThreadedTimeStamp::meta.subTypes() +=  ModeTimeStamp::meta;
		ThreadedTimeStamp::meta.subTypes() +=  ConsumedEventTimeStamp::meta;
		ThreadedTimeStamp::meta.subTypes() +=  RemoteMethodTimeStamp::meta;
		Timestamp::meta.subTypes() +=  PreemptionTimeStamp::meta;
		Timestamp::meta.subTypes() +=  QueueReorderingTimeStamp::meta;
		Timestamp::meta.subTypes() +=  FrameTimeStamp::meta;
		Timestamp::meta.subTypes() +=  ThreadedTimeStamp::meta;
		
	}
	Udm::UdmDiagram diagram = { &umldiagram, Initialize };
}
// END IIF.cpp
